Scriptname RRBoostersScript extends Quest  
{Realistic Regeneration : Boosters}

;
; GLOBAL VARIABLES --------------------------------------------------------------------------------
;

; Game
Actor Property PlayerREF Auto

; Scripts
RRControlScript Property RRControl Auto

; Sprint
GlobalVariable Property RRBoostSprintHealEnabled Auto
GlobalVariable Property RRBoostSprintMagickaEnabled Auto
GlobalVariable Property RRBoostSprintStaminaEnabled Auto

GlobalVariable Property RRBoostSprintHealValue Auto
GlobalVariable Property RRBoostSprintMagickaValue Auto
GlobalVariable Property RRBoostSprintStaminaValue Auto

; Combat
GlobalVariable Property RRBoostCombatHealEnabled Auto
GlobalVariable Property RRBoostCombatMagickaEnabled Auto
GlobalVariable Property RRBoostCombatStaminaEnabled Auto

GlobalVariable Property RRBoostCombatHealValue Auto
GlobalVariable Property RRBoostCombatMagickaValue Auto
GlobalVariable Property RRBoostCombatStaminaValue Auto

;		FATIGUES - Running
GlobalVariable Property RRRelaxRunningHealEnabled Auto
GlobalVariable Property RRRelaxRunningMagickaEnabled Auto
GlobalVariable Property RRRelaxRunningStaminaEnabled Auto

GlobalVariable Property RRRelaxRunningHealValue Auto
GlobalVariable Property RRRelaxRunningMagickaValue Auto
GlobalVariable Property RRRelaxRunningStaminaValue Auto

;		FATIGUES - Sneaking
GlobalVariable Property RRRelaxStealthHealEnabled Auto
GlobalVariable Property RRRelaxStealthMagickaEnabled Auto
GlobalVariable Property RRRelaxStealthStaminaEnabled Auto

GlobalVariable Property RRRelaxStealthHealValue Auto
GlobalVariable Property RRRelaxStealthMagickaValue Auto
GlobalVariable Property RRRelaxStealthStaminaValue Auto

;		FATIGUES - Walking
GlobalVariable Property RRRelaxWalkingHealEnabled Auto
GlobalVariable Property RRRelaxWalkingMagickaEnabled Auto
GlobalVariable Property RRRelaxWalkingStaminaEnabled Auto

GlobalVariable Property RRRelaxWalkingHealValue Auto
GlobalVariable Property RRRelaxWalkingMagickaValue Auto
GlobalVariable Property RRRelaxWalkingStaminaValue Auto


; Timers
GlobalVariable Property RRUpdateBoostersAt Auto

; Hide In UI
GlobalVariable Property RRHideInUI Auto

;
; SPELLS ------------------------------------------------------------------------------------------
;

Spell Property RRBoostSprintHealSpell Auto
Spell Property RRBoostSprintMagickaSpell Auto
Spell Property RRBoostSprintStaminaSpell Auto
Spell Property RRBoostCombatHealSpell Auto
Spell Property RRBoostCombatMagickaSpell Auto
Spell Property RRBoostCombatStaminaSpell Auto


Spell Property RRRelaxRunningHealSpell Auto
Spell Property RRRelaxRunningMagickaSpell Auto
Spell Property RRRelaxRunningStaminaSpell Auto

Spell Property RRRelaxStealthHealSpell Auto
Spell Property RRRelaxStealthMagickaSpell Auto
Spell Property RRRelaxStealthStaminaSpell Auto

Spell Property RRRelaxWalkingHealSpell Auto
Spell Property RRRelaxWalkingMagickaSpell Auto
Spell Property RRRelaxWalkingStaminaSpell Auto

;
; PRIVATE VARIABLES -------------------------------------------------------------------------------
;

GlobalVariable[] gEnabledBoostersList
GlobalVariable[] gBoostersValuesList
Spell[]          sBoostersSpellsList

int Property HideInUI = 0x00008000 autoReadOnly

;
; FUNCTIONS ---------------------------------------------------------------------------------------
;

Function initializeAll()
	initializeVariables()
EndFunction

Function reset()
	deactivate()

	if ( RRControl.isActive() )
		activate()
	endIf
EndFunction

Function activate()
	removeAllSpells()
	setPlayerSettings()
	GotoState( "onAddBoosters" )
	RegisterForSingleUpdate( RRUpdateBoostersAt.GetValue() )
EndFunction

Function deactivate()
	removeAllSpells()
	UnregisterForUpdate()
	GotoState( "Inactive" )
EndFunction

Function initializeVariables()
	gEnabledBoostersList = new GlobalVariable[15]
	gEnabledBoostersList[0] = RRBoostSprintHealEnabled
	gEnabledBoostersList[1] = RRBoostSprintMagickaEnabled
	gEnabledBoostersList[2] = RRBoostSprintStaminaEnabled
	gEnabledBoostersList[3] = RRBoostCombatHealEnabled
	gEnabledBoostersList[4] = RRBoostCombatMagickaEnabled
	gEnabledBoostersList[5] = RRBoostCombatStaminaEnabled
	gEnabledBoostersList[6] = RRRelaxRunningHealEnabled
	gEnabledBoostersList[7] = RRRelaxRunningMagickaEnabled
	gEnabledBoostersList[8] = RRRelaxRunningStaminaEnabled
	gEnabledBoostersList[9] = RRRelaxStealthHealEnabled
	gEnabledBoostersList[10] = RRRelaxStealthMagickaEnabled
	gEnabledBoostersList[11] = RRRelaxStealthStaminaEnabled
	gEnabledBoostersList[12] = RRRelaxWalkingHealEnabled
	gEnabledBoostersList[13] = RRRelaxWalkingMagickaEnabled
	gEnabledBoostersList[14] = RRRelaxWalkingStaminaEnabled
	
	gBoostersValuesList = new GlobalVariable[15]
	gBoostersValuesList[0] = RRBoostSprintHealValue
	gBoostersValuesList[1] = RRBoostSprintMagickaValue
	gBoostersValuesList[2] = RRBoostSprintStaminaValue
	gBoostersValuesList[3] = RRBoostCombatHealValue
	gBoostersValuesList[4] = RRBoostCombatMagickaValue
	gBoostersValuesList[5] = RRBoostCombatStaminaValue
	gBoostersValuesList[6] = RRRelaxRunningHealValue
	gBoostersValuesList[7] = RRRelaxRunningMagickaValue
	gBoostersValuesList[8] = RRRelaxRunningStaminaValue
	gBoostersValuesList[9] = RRRelaxStealthHealValue
	gBoostersValuesList[10] = RRRelaxStealthMagickaValue
	gBoostersValuesList[11] = RRRelaxStealthStaminaValue
	gBoostersValuesList[12] = RRRelaxWalkingHealValue
	gBoostersValuesList[13] = RRRelaxWalkingMagickaValue
	gBoostersValuesList[14] = RRRelaxWalkingStaminaValue

	sBoostersSpellsList = new Spell[15]
	sBoostersSpellsList[0] = RRBoostSprintHealSpell
	sBoostersSpellsList[1] = RRBoostSprintMagickaSpell
	sBoostersSpellsList[2] = RRBoostSprintStaminaSpell
	sBoostersSpellsList[3] = RRBoostCombatHealSpell
	sBoostersSpellsList[4] = RRBoostCombatMagickaSpell
	sBoostersSpellsList[5] = RRBoostCombatStaminaSpell
	sBoostersSpellsList[6] = RRRelaxRunningHealSpell
	sBoostersSpellsList[7] = RRRelaxRunningMagickaSpell
	sBoostersSpellsList[8] = RRRelaxRunningStaminaSpell
	sBoostersSpellsList[9] = RRRelaxStealthHealSpell
	sBoostersSpellsList[10] = RRRelaxStealthMagickaSpell
	sBoostersSpellsList[11] = RRRelaxStealthStaminaSpell
	sBoostersSpellsList[12] = RRRelaxWalkingHealSpell
	sBoostersSpellsList[13] = RRRelaxWalkingMagickaSpell
	sBoostersSpellsList[14] = RRRelaxWalkingStaminaSpell
EndFunction

Function removeAllSpells()
	RRControl.removeAllSpellsFromList( sBoostersSpellsList )
EndFunction

Function addBoostersSpells()
	int iIndex = 0
	bool bDebug = RRControl.isDebug()

	While ( iIndex < gEnabledBoostersList.Length )
		if ( gEnabledBoostersList[iIndex].GetValueInt() == 1 )
			PlayerREF.AddSpell( sBoostersSpellsList[iIndex], bDebug )
		endIf

		iIndex += 1
	EndWhile
EndFunction

Function setPlayerSettings()
	int iIndex = 0

	While ( iIndex < gEnabledBoostersList.Length )
		Spell aSpell = sBoostersSpellsList[iIndex]
		float fMagnitude = gBoostersValuesList[iIndex].GetValue()

		setEffectMagnitude( aSpell, fMagnitude )
		iIndex += 1
	EndWhile
EndFunction

Function setEffectMagnitude( Spell aSpell, float fMagnitude )
	MagicEffect spellEffect = aSpell.GetNthEffectMagicEffect( 0 )

	if ( RRHideInUI.GetValueInt() == 1 )
		if ( !spellEffect.IsEffectFlagSet( HideInUI ) )
			spellEffect.SetEffectFlag( HideInUI )
		endIf
	else
		if ( spellEffect.IsEffectFlagSet( HideInUI ) )
			spellEffect.ClearEffectFlag( HideInUI )
		endIf
	endIf

	aSpell.SetNthEffectMagnitude( 0, fMagnitude )
EndFunction

;
; EVENTS & STATES ---------------------------------------------------------------------------------
;

State OnAddBoosters
	Event OnUpdate()
		if ( !RRControl.isActive() )
			deactivate()
			return
		endIf

		if ( RRControl.isDebug() )
			Debug.Notification( "Adding Boosters..." )
		endIf

		addBoostersSpells()

		UnregisterForUpdate()
		GotoState("Inactive")
	EndEvent
EndState

State Inactive
	Event OnUpdate()
		; nop
	EndEvent
EndState

Event OnUpdate()
	; nop
EndEvent
