Scriptname RRConfigAttributesScript extends RRConfigBoostersScript  
{Realistic Regeneration for SkyUI : Attributes Script}

; +-RRSkyUIConfigParentScript
; +-+-RRConfigHelpScript
;   +-+-RRConfigSlidersScript
;     +-+-RRConfigTemplatesScript
;       +-+-RRConfigMiscScript
;         +-+-RRConfigBeastFormScript
;           +-+-RRConfigCombatScript
;             +-+-RRConfigBoostersScript
;               +-+-RRConfigAttributesScript
;                 +-+-RRSkyUIConfigMenuScript

;
; PRIVATE VARIABLES -------------------------------------------------------------------------------
;

string  Property sModifierFS = "{0}" autoReadOnly
float[] Property AttributesList Auto Hidden
GlobalVariable[] Property gvModifiersList Auto Hidden


;
; FUNCTIONS ---------------------------------------------------------------------------------------
;

Function updateAttributesFlags()
	; nop
EndFunction

Function generateAttributesPage()
	SetCursorFillMode( TOP_TO_BOTTOM )

	AttributesList = RRControl.getBaseAttrList()
	; 0 - Health
	; 1 - Magicka
	; 2 - Stamina

	;
	; fix interface "bug"
	;
	;gvModifiersList = new GlobalVariable[3]
	;gvModifiersList[0] = RRAttrHealthModifier
	;gvModifiersList[1] = RRAttrMagickaModifier
	;gvModifiersList[2] = RRAttrStaminaModifier

	;int iIndex = 0
	;while ( iIndex < AttributesList.Length )
	;	float fReal = AttributesList[iIndex] - gvModifiersList[iIndex].GetValue()
	;	AttributesList[iIndex] = fReal
	;	iIndex += 1
	;endWhile

	AddHeaderOption( "$Health", _modEnabledFlags )
	AddTextOptionST( "HEALTH_ATTR_CURRENT", "$RRCurrent", Math.Floor( AttributesList[0] ), _modEnabledFlags )
	AddSliderOptionST( "HEALTH_ATTR_MODIFIER", "$RRModifier", RRAttrHealthModifier.GetValueInt(), sModifierFS, _modEnabledFlags )
	AddTextOptionST( "HEALTH_ATTR_NEW", "$RRNewValue", Math.Floor( AttributesList[0] + RRAttrHealthModifier.GetValueInt() ), _modEnabledFlags )

	AddHeaderOption( "$Magicka", _modEnabledFlags )
	AddTextOptionST( "MAGICKA_ATTR_CURRENT", "$RRCurrent", Math.Floor( AttributesList[1] ), _modEnabledFlags )
	AddSliderOptionST( "MAGICKA_ATTR_MODIFIER", "$RRModifier", RRAttrMagickaModifier.GetValueInt(), sModifierFS, _modEnabledFlags )
	AddTextOptionST( "MAGICKA_ATTR_NEW", "$RRNewValue", Math.Floor( AttributesList[1] + RRAttrMagickaModifier.GetValueInt() ), _modEnabledFlags )

	AddHeaderOption( "$Stamina", _modEnabledFlags )
	AddTextOptionST( "STAMINA_ATTR_CURRENT", "$RRCurrent", Math.Floor( AttributesList[2] ), _modEnabledFlags )
	AddSliderOptionST( "STAMINA_ATTR_MODIFIER", "$RRModifier", RRAttrStaminaModifier.GetValueInt(), sModifierFS, _modEnabledFlags )
	AddTextOptionST( "STAMINA_ATTR_NEW", "$RRNewValue", Math.Floor( AttributesList[2] + RRAttrStaminaModifier.GetValueInt() ), _modEnabledFlags )

	SetCursorPosition(1)

	AddHeaderOption( "$RRSlidersHealth", _modEnabledFlags )
	AddSliderOptionST( "SLIDER_ATTR_HEALTH_MIN", "$RRMinimum", RRsliderAttrHealthMin.GetValue(), sModifierFS, _modEnabledFlags )
	AddSliderOptionST( "SLIDER_ATTR_HEALTH_MAX", "$RRMaximum", RRsliderAttrHealthMax.GetValue(), sModifierFS, _modEnabledFlags )
	AddSliderOptionST( "SLIDER_ATTR_HEALTH_INT", "$RRInterval", RRsliderAttrHealthInterval.GetValue(), sModifierFS, _modEnabledFlags )

	AddHeaderOption( "$RRSlidersMagicka", _modEnabledFlags )
	AddSliderOptionST( "SLIDER_ATTR_MAGICKA_MIN", "$RRMinimum", RRsliderAttrMagickaMin.GetValue(), sModifierFS, _modEnabledFlags )
	AddSliderOptionST( "SLIDER_ATTR_MAGICKA_MAX", "$RRMaximum", RRsliderAttrMagickaMax.GetValue(), sModifierFS, _modEnabledFlags )
	AddSliderOptionST( "SLIDER_ATTR_MAGICKA_INT", "$RRInterval", RRsliderAttrMagickaInterval.GetValue(), sModifierFS, _modEnabledFlags )

	AddHeaderOption( "$RRSlidersStamina", _modEnabledFlags )
	AddSliderOptionST( "SLIDER_ATTR_STAMINA_MIN", "$RRMinimum", RRsliderAttrStaminaMin.GetValue(), sModifierFS, _modEnabledFlags )
	AddSliderOptionST( "SLIDER_ATTR_STAMINA_MAX", "$RRMaximum", RRsliderAttrStaminaMax.GetValue(), sModifierFS, _modEnabledFlags )
	AddSliderOptionST( "SLIDER_ATTR_STAMINA_INT", "$RRInterval", RRsliderAttrStaminaInterval.GetValue(), sModifierFS, _modEnabledFlags )
EndFunction

;
; STATE Attributes --------------------------------------------------------------------------------
;

State HEALTH_ATTR_CURRENT ; TEXT
	event OnHighlightST()
		SetInfoText( "$RRhintAttrCurrent" )
	endEvent
EndState

State HEALTH_ATTR_MODIFIER ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRAttrHealthModifier.GetValue() )
		SetSliderDialogDefaultValue( 0.0 )
		SetSliderDialogRange( RRsliderAttrHealthMin.GetValue(), RRsliderAttrHealthMax.GetValue() )
		SetSliderDialogInterval( RRsliderAttrHealthInterval.GetValue() )
	endEvent

	event OnSliderAcceptST( float value )
		RRAttrHealthModifier.SetValue( value )
		SetSliderOptionValueST( RRAttrHealthModifier.GetValue(), sModifierFS )
		SetTextOptionValueST( Math.Floor( AttributesList[0] + RRAttrHealthModifier.GetValueInt() ), false, "HEALTH_ATTR_NEW" )
	endEvent

	event OnDefaultST()
		RRAttrHealthModifier.SetValue( 0.0 )
		SetSliderOptionValueST( RRAttrHealthModifier.GetValue(), sModifierFS )
		SetTextOptionValueST( Math.Floor( AttributesList[0] + RRAttrHealthModifier.GetValueInt() ), false, "HEALTH_ATTR_NEW" )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintAttributes" )
	endEvent
EndState

State HEALTH_ATTR_NEW ; TEXT
	event OnHighlightST()
		SetInfoText( "$RRhintAttrNew" )
	endEvent
EndState


State MAGICKA_ATTR_CURRENT ; TEXT
	event OnHighlightST()
		SetInfoText( "$RRhintAttrCurrent" )
	endEvent
EndState

State MAGICKA_ATTR_MODIFIER ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRAttrMagickaModifier.GetValue() )
		SetSliderDialogDefaultValue( 0.0 )
		SetSliderDialogRange( RRsliderAttrMagickaMin.GetValue(), RRsliderAttrMagickaMax.GetValue() )
		SetSliderDialogInterval( RRsliderAttrMagickaInterval.GetValue() )
	endEvent

	event OnSliderAcceptST( float value )
		RRAttrMagickaModifier.SetValue( value )
		SetSliderOptionValueST( RRAttrMagickaModifier.GetValue(), sModifierFS )
		SetTextOptionValueST( Math.Floor( AttributesList[1] + RRAttrMagickaModifier.GetValueInt() ), false, "MAGICKA_ATTR_NEW" )
	endEvent

	event OnDefaultST()
		RRAttrMagickaModifier.SetValue( 0.0 )
		SetSliderOptionValueST( RRAttrMagickaModifier.GetValue(), sModifierFS )
		SetTextOptionValueST( Math.Floor( AttributesList[1] + RRAttrMagickaModifier.GetValueInt() ), false, "MAGICKA_ATTR_NEW" )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintAttributes" )
	endEvent
EndState

State MAGICKA_ATTR_NEW ; TEXT
	event OnHighlightST()
		SetInfoText( "$RRhintAttrNew" )
	endEvent
EndState


State STAMINA_ATTR_CURRENT ; TEXT
	event OnHighlightST()
		SetInfoText( "$RRhintAttrCurrent" )
	endEvent
EndState

State STAMINA_ATTR_MODIFIER ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRAttrStaminaModifier.GetValue() )
		SetSliderDialogDefaultValue( 0.0 )
		SetSliderDialogRange( RRsliderAttrStaminaMin.GetValue(), RRsliderAttrStaminaMax.GetValue() )
		SetSliderDialogInterval( RRsliderAttrStaminaInterval.GetValue() )
	endEvent

	event OnSliderAcceptST( float value )
		RRAttrStaminaModifier.SetValue( value )
		SetSliderOptionValueST( RRAttrStaminaModifier.GetValue(), sModifierFS )
		SetTextOptionValueST( Math.Floor( AttributesList[2] + RRAttrStaminaModifier.GetValueInt() ), false, "STAMINA_ATTR_NEW" )
	endEvent

	event OnDefaultST()
		RRAttrStaminaModifier.SetValue( 0.0 )
		SetSliderOptionValueST( RRAttrStaminaModifier.GetValue(), sModifierFS )
		SetTextOptionValueST( Math.Floor( AttributesList[2] + RRAttrStaminaModifier.GetValueInt() ), false, "STAMINA_ATTR_NEW" )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintAttributes" )
	endEvent
EndState

State STAMINA_ATTR_NEW ; TEXT
	event OnHighlightST()
		SetInfoText( "$RRhintAttrNew" )
	endEvent
EndState

;
; STATE Attributes : Sliders ----------------------------------------------------------------------
;

State SLIDER_ATTR_HEALTH_MIN ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderAttrHealthMin.GetValue() )
		SetSliderDialogDefaultValue( -100.0 )
		SetSliderDialogRange( -1000.0, 0.0 )
		SetSliderDialogInterval( 10.0 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderAttrHealthMin.SetValue( value )
		SetSliderOptionValueST( RRsliderAttrHealthMin.GetValue(), sModifierFS )
	endEvent

	event OnDefaultST()
		RRsliderAttrHealthMin.SetValue( -100.0 )
		SetSliderOptionValueST( RRsliderAttrHealthMin.GetValue(), sModifierFS )
	endEvent
EndState

State SLIDER_ATTR_HEALTH_MAX ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderAttrHealthMax.GetValue() )
		SetSliderDialogDefaultValue( 100.0 )
		SetSliderDialogRange( 0.0, 1000.0 )
		SetSliderDialogInterval( 10.0 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderAttrHealthMax.SetValue( value )
		SetSliderOptionValueST( RRsliderAttrHealthMax.GetValue(), sModifierFS )
	endEvent

	event OnDefaultST()
		RRsliderAttrHealthMax.SetValue( 100.0 )
		SetSliderOptionValueST( RRsliderAttrHealthMax.GetValue(), sModifierFS )
	endEvent
EndState

State SLIDER_ATTR_HEALTH_INT ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderAttrHealthInterval.GetValue() )
		SetSliderDialogDefaultValue( 5.0 )
		SetSliderDialogRange( 1.0, 50.0 )
		SetSliderDialogInterval( 1.0 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderAttrHealthInterval.SetValue( value )
		SetSliderOptionValueST( RRsliderAttrHealthInterval.GetValue(), sModifierFS )
	endEvent

	event OnDefaultST()
		RRsliderAttrHealthInterval.SetValue( 5.0 )
		SetSliderOptionValueST( RRsliderAttrHealthInterval.GetValue(), sModifierFS )
	endEvent
EndState


State SLIDER_ATTR_MAGICKA_MIN ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderAttrMagickaMin.GetValue() )
		SetSliderDialogDefaultValue( -100.0 )
		SetSliderDialogRange( -1000.0, 0.0 )
		SetSliderDialogInterval( 10.0 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderAttrMagickaMin.SetValue( value )
		SetSliderOptionValueST( RRsliderAttrMagickaMin.GetValue(), sModifierFS )
	endEvent

	event OnDefaultST()
		RRsliderAttrMagickaMin.SetValue( -100.0 )
		SetSliderOptionValueST( RRsliderAttrMagickaMin.GetValue(), sModifierFS )
	endEvent
EndState

State SLIDER_ATTR_MAGICKA_MAX ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderAttrMagickaMax.GetValue() )
		SetSliderDialogDefaultValue( 100.0 )
		SetSliderDialogRange( 0.0, 1000.0 )
		SetSliderDialogInterval( 10.0 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderAttrMagickaMax.SetValue( value )
		SetSliderOptionValueST( RRsliderAttrMagickaMax.GetValue(), sModifierFS )
	endEvent

	event OnDefaultST()
		RRsliderAttrMagickaMax.SetValue( 100.0 )
		SetSliderOptionValueST( RRsliderAttrMagickaMax.GetValue(), sModifierFS )
	endEvent
EndState

State SLIDER_ATTR_MAGICKA_INT ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderAttrMagickaInterval.GetValue() )
		SetSliderDialogDefaultValue( 5.0 )
		SetSliderDialogRange( 1.0, 50.0 )
		SetSliderDialogInterval( 1.0 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderAttrMagickaInterval.SetValue( value )
		SetSliderOptionValueST( RRsliderAttrMagickaInterval.GetValue(), sModifierFS )
	endEvent

	event OnDefaultST()
		RRsliderAttrMagickaInterval.SetValue( 5.0 )
		SetSliderOptionValueST( RRsliderAttrMagickaInterval.GetValue(), sModifierFS )
	endEvent
EndState


State SLIDER_ATTR_STAMINA_MIN ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderAttrStaminaMin.GetValue() )
		SetSliderDialogDefaultValue( -100.0 )
		SetSliderDialogRange( -1000.0, 0.0 )
		SetSliderDialogInterval( 10.0 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderAttrStaminaMin.SetValue( value )
		SetSliderOptionValueST( RRsliderAttrStaminaMin.GetValue(), sModifierFS )
	endEvent

	event OnDefaultST()
		RRsliderAttrStaminaMin.SetValue( -100.0 )
		SetSliderOptionValueST( RRsliderAttrStaminaMin.GetValue(), sModifierFS )
	endEvent
EndState

State SLIDER_ATTR_STAMINA_MAX ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderAttrStaminaMax.GetValue() )
		SetSliderDialogDefaultValue( 100.0 )
		SetSliderDialogRange( 0.0, 1000.0 )
		SetSliderDialogInterval( 10.0 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderAttrStaminaMax.SetValue( value )
		SetSliderOptionValueST( RRsliderAttrStaminaMax.GetValue(), sModifierFS )
	endEvent

	event OnDefaultST()
		RRsliderAttrStaminaMax.SetValue( 100.0 )
		SetSliderOptionValueST( RRsliderAttrStaminaMax.GetValue(), sModifierFS )
	endEvent
EndState

State SLIDER_ATTR_STAMINA_INT ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderAttrStaminaInterval.GetValue() )
		SetSliderDialogDefaultValue( 5.0 )
		SetSliderDialogRange( 1.0, 50.0 )
		SetSliderDialogInterval( 1.0 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderAttrStaminaInterval.SetValue( value )
		SetSliderOptionValueST( RRsliderAttrStaminaInterval.GetValue(), sModifierFS )
	endEvent

	event OnDefaultST()
		RRsliderAttrStaminaInterval.SetValue( 5.0 )
		SetSliderOptionValueST( RRsliderAttrStaminaInterval.GetValue(), sModifierFS )
	endEvent
EndState
