Scriptname RRConfigBeastFormScript extends RRConfigMiscScript Hidden 
{Realistic Regeneration for SkyUI : Beast Form Page}

; +-RRSkyUIConfigParentScript
; +-+-RRConfigHelpScript
;   +-+-RRConfigSlidersScript
;     +-+-RRConfigTemplatesScript
;       +-+-RRConfigMiscScript
;         +-+-RRConfigBeastFormScript
;           +-+-RRConfigCombatScript
;             +-+-RRConfigBoostersScript
;               +-+-RRConfigAttributesScript
;                 +-+-RRSkyUIConfigMenuScript

;
; PAGE BeastForm ----------------------------------------------------------------------------------
;

Function generateBeastFormPage()
	SetCursorFillMode( TOP_TO_BOTTOM )

	AddToggleOptionST( "BEASTFORM_WEREWOLF", "$RRWerewolf", RRWerewolfIndex.GetValueInt(), _modEnabledFlags )
	AddToggleOptionST( "WEREWOLF_RESTORE_GS", "$RRWerewolfRestoreGS", RRWerewolfRestoreGS.GetValueInt(), _werewolfFlags )
	AddEmptyOption()

	int rIndex = RRWerewolfHealRateIndex.GetValueInt()
	string rName = _defaultOptionsList[rIndex]
	float rValue = RRSkyUILib.getRRCVWerewolf( rIndex, RRWerewolfHealRateValue, "Health" )

	AddMenuOptionST( "WEREWOLF_HEAL_TYPE", "$Health", rName, _werewolfFlags )
	AddSliderOptionST( "WEREWOLF_HEAL_VALUE", "$Value", rValue, _sliderFS, _werewolfHealFlags )
	AddEmptyOption()

	rIndex = RRWerewolfMagickaRateIndex.GetValueInt()
	rName = _defaultOptionsList[rIndex]
	rValue = RRSkyUILib.getRRCVWerewolf( rIndex, RRWerewolfMagickaRateValue, "Magicka" )

	AddMenuOptionST( "WEREWOLF_MAGICKA_TYPE", "$Magicka", rName, _werewolfFlags )
	AddSliderOptionST( "WEREWOLF_MAGICKA_VALUE", "$Value", rValue, _sliderFS, _werewolfMagickaFlags )
	AddEmptyOption()

	rIndex = RRWerewolfStaminaRateIndex.GetValueInt()
	rName = _defaultOptionsList[rIndex]
	rValue = RRSkyUILib.getRRCVWerewolf( rIndex, RRWerewolfStaminaRateValue, "Stamina" )

	AddMenuOptionST( "WEREWOLF_STAMINA_TYPE", "$Stamina", rName, _werewolfFlags )
	AddSliderOptionST( "WEREWOLF_STAMINA_VALUE", "$Value", rValue, _sliderFS, _werewolfStaminaFlags )
endFunction

;
; FUNCTIONS : BeastForm ---------------------------------------------------------------------------
;

Function updateBeastFormFlags()
	if ( updateModEnabledFlags() )
		if ( RRWerewolfIndex.GetValueInt() == 1 )
			_werewolfFlags = OPTION_FLAG_NONE

			if ( RRWerewolfHealRateIndex.GetValueInt() == RRFunctionUserDefined.GetValue() )
				_werewolfHealFlags = OPTION_FLAG_NONE
			else
				_werewolfHealFlags = OPTION_FLAG_DISABLED
			endIf

			if ( RRWerewolfMagickaRateIndex.GetValueInt() == RRFunctionUserDefined.GetValue() )
				_werewolfMagickaFlags = OPTION_FLAG_NONE
			else
				_werewolfMagickaFlags = OPTION_FLAG_DISABLED
			endIf

			if ( RRWerewolfStaminaRateIndex.GetValueInt() == RRFunctionUserDefined.GetValue() )
				_werewolfStaminaFlags = OPTION_FLAG_NONE
			else
				_werewolfStaminaFlags = OPTION_FLAG_DISABLED
			endIf
		else
			_werewolfFlags = OPTION_FLAG_DISABLED
			_werewolfHealFlags = OPTION_FLAG_DISABLED
			_werewolfMagickaFlags = OPTION_FLAG_DISABLED
			_werewolfStaminaFlags = OPTION_FLAG_DISABLED
		endIf
	else
		_werewolfFlags = OPTION_FLAG_DISABLED
		_werewolfHealFlags = OPTION_FLAG_DISABLED
		_werewolfMagickaFlags = OPTION_FLAG_DISABLED
		_werewolfStaminaFlags = OPTION_FLAG_DISABLED
	endIf
endFunction

Function updateBeastFormOptions()
	SetOptionFlagsST(_werewolfFlags, false, "WEREWOLF_RESTORE_GS")

	SetOptionFlagsST(_werewolfFlags, false, "WEREWOLF_HEAL_TYPE")
	SetOptionFlagsST(_werewolfFlags, false, "WEREWOLF_MAGICKA_TYPE")
	SetOptionFlagsST(_werewolfFlags, false, "WEREWOLF_STAMINA_TYPE")

	SetOptionFlagsST(_werewolfHealFlags, false, "WEREWOLF_HEAL_VALUE")
	SetOptionFlagsST(_werewolfMagickaFlags, false, "WEREWOLF_MAGICKA_VALUE")
	SetOptionFlagsST(_werewolfStaminaFlags, false, "WEREWOLF_STAMINA_VALUE")

	int rIndex = RRWerewolfHealRateIndex.GetValueInt()
	float rValue = RRSkyUILib.getRRCVWerewolf( rIndex, RRWerewolfHealRateValue, "Health")
	SetSliderOptionValueST( rValue, _sliderFS, false, "WEREWOLF_HEAL_VALUE" )

	rIndex = RRWerewolfMagickaRateIndex.GetValueInt()
	rValue = RRSkyUILib.getRRCVWerewolf( rIndex, RRWerewolfMagickaRateValue, "Magicka")
	SetSliderOptionValueST( rValue, _sliderFS, false, "WEREWOLF_MAGICKA_VALUE" )

	rIndex = RRWerewolfStaminaRateIndex.GetValueInt()
	rValue = RRSkyUILib.getRRCVWerewolf( rIndex, RRWerewolfStaminaRateValue, "Stamina")
	SetSliderOptionValueST( rValue, _sliderFS, false, "WEREWOLF_STAMINA_VALUE" )
EndFunction

;
; STATE BeastForm ---------------------------------------------------------------------------------
;
; STATE BeastForm : Menus -------------------------------------------------------------------------
;

state BEASTFORM_WEREWOLF ; TOGGLE
	event onSelectST()
		RRSkyUILib.toggle( RRWerewolfIndex )
		SetToggleOptionValueST( RRWerewolfIndex.GetValueInt() )
		updateBeastFormFlags()
		updateBeastFormOptions()
	endEvent

	event OnDefaultST()
		RRWerewolfIndex.SetValueInt( 0 )
		SetMenuOptionValueST( RRWerewolfIndex.GetValueInt() )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintBeastForm" )
	endEvent
endState

state WEREWOLF_RESTORE_GS ; TOGGLE
	event onSelectST()
		RRSkyUILib.toggle( RRWerewolfRestoreGS )
		SetToggleOptionValueST( RRWerewolfRestoreGS.GetValueInt() )
	endEvent

	event OnDefaultST()
		RRWerewolfRestoreGS.SetValueInt( 1 )
		SetMenuOptionValueST( RRWerewolfRestoreGS.GetValueInt() )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintWerewolfRestoreGS" )
	endEvent
endState

;
; STATE BeastForm : Menus -------------------------------------------------------------------------
;

state WEREWOLF_HEAL_TYPE ; MENU
	event OnMenuOpenST()
		SetMenuDialogStartIndex( RRWerewolfHealRateIndex.GetValueInt() )
		SetMenuDialogDefaultIndex( RRFunctionDefault.GetValueInt() )
		SetMenuDialogOptions( _defaultOptionsList )
	endEvent

	event OnMenuAcceptST( int index )
		RRWerewolfHealRateIndex.SetValueInt( index )
		SetMenuOptionValueST( _defaultOptionsList[index] )
		updateBeastFormFlags()
		updateBeastFormOptions()
	endEvent

	event OnDefaultST()
		RRWerewolfHealRateIndex.SetValueInt( 3 )
		SetMenuOptionValueST( _defaultOptionsList[3] )
		updateBeastFormFlags()
		updateBeastFormOptions()
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintWerewolfType" )
	endEvent
endState

state WEREWOLF_MAGICKA_TYPE ; MENU
	event OnMenuOpenST()
		SetMenuDialogStartIndex( RRWerewolfMagickaRateIndex.GetValueInt() )
		SetMenuDialogDefaultIndex( RRFunctionDefault.GetValueInt() )
		SetMenuDialogOptions( _defaultOptionsList )
	endEvent

	event OnMenuAcceptST( int index )
		RRWerewolfMagickaRateIndex.SetValueInt( index )
		SetMenuOptionValueST( _defaultOptionsList[index] )
		updateBeastFormFlags()
		updateBeastFormOptions()
	endEvent

	event OnDefaultST()
		RRWerewolfMagickaRateIndex.SetValueInt( 3 )
		SetMenuOptionValueST( _defaultOptionsList[3] )
		updateBeastFormFlags()
		updateBeastFormOptions()
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintWerewolfType" )
	endEvent
endState

state WEREWOLF_STAMINA_TYPE ; MENU
	event OnMenuOpenST()
		SetMenuDialogStartIndex( RRWerewolfStaminaRateIndex.GetValueInt() )
		SetMenuDialogDefaultIndex( RRFunctionDefault.GetValueInt() )
		SetMenuDialogOptions( _defaultOptionsList )
	endEvent

	event OnMenuAcceptST( int index )
		RRWerewolfStaminaRateIndex.SetValueInt( index )
		SetMenuOptionValueST( _defaultOptionsList[index] )
		updateBeastFormFlags()
		updateBeastFormOptions()
	endEvent

	event OnDefaultST()
		RRWerewolfStaminaRateIndex.SetValueInt( 3 )
		SetMenuOptionValueST( _defaultOptionsList[3] )
		updateBeastFormFlags()
		updateBeastFormOptions()
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintWerewolfType" )
	endEvent
endState

;
; STATE BeastForm : Sliders -----------------------------------------------------------------------
;

state WEREWOLF_HEAL_VALUE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRWerewolfHealRateValue.GetValue() )
		SetSliderDialogDefaultValue( 0.0 )
		SetSliderDialogRange( RRsliderHealMin.GetValue(), RRsliderHealMax.GetValue() )
		SetSliderDialogInterval( RRsliderHealInterval.GetValue() )
	endEvent

	event OnSliderAcceptST( float value )
		RRWerewolfHealRateValue.SetValue( value )
		SetSliderOptionValueST( RRWerewolfHealRateValue.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRWerewolfHealRateValue.SetValue( 0.0 )
		SetSliderOptionValueST( RRWerewolfHealRateValue.GetValue(), _sliderFS )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintValue" )
	endEvent
endState

state WEREWOLF_MAGICKA_VALUE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRWerewolfMagickaRateValue.GetValue() )
		SetSliderDialogDefaultValue( 3.0 )
		SetSliderDialogRange( RRsliderMagickaMin.GetValue(), RRsliderMagickaMax.GetValue() )
		SetSliderDialogInterval( RRsliderMagickaInterval.GetValue() )
	endEvent

	event OnSliderAcceptST( float value )
		RRWerewolfMagickaRateValue.SetValue( value )
		SetSliderOptionValueST( RRWerewolfMagickaRateValue.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRWerewolfMagickaRateValue.SetValue( 3.0 )
		SetSliderOptionValueST( RRWerewolfMagickaRateValue.GetValue(), _sliderFS )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintValue" )
	endEvent
endState

state WEREWOLF_STAMINA_VALUE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRWerewolfStaminaRateValue.GetValue() )
		SetSliderDialogDefaultValue( 20.0 )
		SetSliderDialogRange( RRsliderStaminaMin.GetValue(), 100.0 )
		SetSliderDialogInterval( RRsliderStaminaInterval.GetValue() )
	endEvent

	event OnSliderAcceptST( float value )
		RRWerewolfStaminaRateValue.SetValue( value )
		SetSliderOptionValueST( RRWerewolfStaminaRateValue.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRWerewolfStaminaRateValue.SetValue( 20.0 )
		SetSliderOptionValueST( RRWerewolfStaminaRateValue.GetValue(), _sliderFS )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintValue" )
	endEvent
endState
