Scriptname RRConfigBoostersScript extends RRConfigCombatScript Hidden 
{Realistic Regeneration for SkyUI : Courage & Fatigue Page}

; +-RRSkyUIConfigParentScript
; +-+-RRConfigHelpScript
;   +-+-RRConfigSlidersScript
;     +-+-RRConfigTemplatesScript
;       +-+-RRConfigMiscScript
;         +-+-RRConfigBeastFormScript
;           +-+-RRConfigCombatScript
;             +-+-RRConfigBoostersScript
;               +-+-RRConfigAttributesScript
;                 +-+-RRSkyUIConfigMenuScript

;
; PRIVATE VARIABLES -------------------------------------------------------------------------------
;

; indexes
int Property iLeftPane  = 0 Auto Hidden
int Property iRightPane = 0 Auto Hidden

float Property fCourageMin       = 0.0   autoReadOnly
float Property fCourageMax       = 20.0  autoReadOnly
float Property fCourageInterval  = 0.1   autoReadOnly

float Property fFatigueInterval  = 0.01  autoReadOnly


; LEFT PANE

string[]           sLeftPaneHeaderList

GlobalVariable[]   sLeftPaneHealIndexList
GlobalVariable[]   sLeftPaneHealValueList

GlobalVariable[]   sLeftPaneMagickaIndexList
GlobalVariable[]   sLeftPaneMagickaValueList

GlobalVariable[]   sLeftPaneStaminaIndexList
GlobalVariable[]   sLeftPaneStaminaValueList

int[]              iLeftPaneHealFlags
int[]              iLeftPaneMagickaFlags
int[]              iLeftPaneStaminaFlags

string[]           sLeftPaneHealHints
string[]           sLeftPaneMagickaHints
string[]           sLeftPaneStaminaHints

; RIGHT PANE

string[]           sRightPaneHeaderList

GlobalVariable[]   sRightPaneHealIndexList
GlobalVariable[]   sRightPaneHealValueList

GlobalVariable[]   sRightPaneMagickaIndexList
GlobalVariable[]   sRightPaneMagickaValueList

GlobalVariable[]   sRightPaneStaminaIndexList
GlobalVariable[]   sRightPaneStaminaValueList

int[]              iRightPaneHealFlags
int[]              iRightPaneMagickaFlags
int[]              iRightPaneStaminaFlags

string[]           sRightPaneHealHints
string[]           sRightPaneMagickaHints
string[]           sRightPaneStaminaHints


;
; FUNCTIONS ---------------------------------------------------------------------------------------
;

Function initializeAll()
	parent.initializeAll()

	;              LEFT PANE // COURAGE

	sLeftPaneHeaderList = new string[2]
	sLeftPaneHeaderList[0] = "$RRSprint"
	sLeftPaneHeaderList[1] = "$RRCombat"

	; Health

	sLeftPaneHealIndexList = new GlobalVariable[2]
	sLeftPaneHealIndexList[0] = RRBoostSprintHealEnabled
	sLeftPaneHealIndexList[1] = RRBoostCombatHealEnabled

	sLeftPaneHealValueList = new GlobalVariable[2]
	sLeftPaneHealValueList[0] = RRBoostSprintHealValue
	sLeftPaneHealValueList[1] = RRBoostCombatHealValue

	iLeftPaneHealFlags = new int[2]
	iLeftPaneHealFlags[0] = OPTION_FLAG_NONE
	iLeftPaneHealFlags[1] = OPTION_FLAG_NONE

	sLeftPaneHealHints = new string[2]
	sLeftPaneHealHints[0] = "$RRhintBoosterHealSprint"
	sLeftPaneHealHints[1] = "$RRhintBoosterHealCombat"

	; Magicka

	sLeftPaneMagickaIndexList = new GlobalVariable[2]
	sLeftPaneMagickaIndexList[0] = RRBoostSprintMagickaEnabled
	sLeftPaneMagickaIndexList[1] = RRBoostCombatMagickaEnabled

	sLeftPaneMagickaValueList = new GlobalVariable[2]
	sLeftPaneMagickaValueList[0] = RRBoostSprintMagickaValue
	sLeftPaneMagickaValueList[1] = RRBoostCombatMagickaValue

	iLeftPaneMagickaFlags = new int[2]
	iLeftPaneMagickaFlags[0] = OPTION_FLAG_NONE
	iLeftPaneMagickaFlags[1] = OPTION_FLAG_NONE

	sLeftPaneMagickaHints = new string[2]
	sLeftPaneMagickaHints[0] = "$RRhintBoosterMagickaSprint"
	sLeftPaneMagickaHints[1] = "$RRhintBoosterMagickaCombat"

	; Stamina

	sLeftPaneStaminaIndexList = new GlobalVariable[2]
	sLeftPaneStaminaIndexList[0] = RRBoostSprintStaminaEnabled
	sLeftPaneStaminaIndexList[1] = RRBoostCombatStaminaEnabled

	sLeftPaneStaminaValueList = new GlobalVariable[2]
	sLeftPaneStaminaValueList[0] = RRBoostSprintStaminaValue
	sLeftPaneStaminaValueList[1] = RRBoostCombatStaminaValue

	iLeftPaneStaminaFlags = new int[2]
	iLeftPaneStaminaFlags[0] = OPTION_FLAG_NONE
	iLeftPaneStaminaFlags[1] = OPTION_FLAG_NONE

	sLeftPaneStaminaHints = new string[2]
	sLeftPaneStaminaHints[0] = "$RRhintBoosterStaminaSprint"
	sLeftPaneStaminaHints[1] = "$RRhintBoosterStaminaCombat"

	;              RIGHT PANE // FATIGUE

	sRightPaneHeaderList = new string[4]
	sRightPaneHeaderList[0] = "$RRNock"
    sRightPaneHeaderList[1] = "$RRRunning"
    sRightPaneHeaderList[2] = "$RRSneaking"
	sRightPaneHeaderList[3] = "$RRWalking"

	; Health

	sRightPaneHealIndexList = new GlobalVariable[4]
	sRightPaneHealIndexList[0] = RRRelaxArrowHealEnabled
	sRightPaneHealIndexList[1] = RRRelaxRunningHealEnabled
	sRightPaneHealIndexList[2] = RRRelaxStealthHealEnabled
	sRightPaneHealIndexList[3] = RRRelaxWalkingHealEnabled

	sRightPaneHealValueList = new GlobalVariable[4]
	sRightPaneHealValueList[0] = RRRelaxArrowHealValue
	sRightPaneHealValueList[1] = RRRelaxRunningHealValue
	sRightPaneHealValueList[2] = RRRelaxStealthHealValue
	sRightPaneHealValueList[3] = RRRelaxWalkingHealValue

	iRightPaneHealFlags = new int[4]
	iRightPaneHealFlags[0] = OPTION_FLAG_NONE
	iRightPaneHealFlags[1] = OPTION_FLAG_NONE
	iRightPaneHealFlags[2] = OPTION_FLAG_NONE
	iRightPaneHealFlags[3] = OPTION_FLAG_NONE

	sRightPaneHealHints = new string[4]
	sRightPaneHealHints[0] = "$RRhintFatigueHealNock"
	sRightPaneHealHints[1] = "$RRhintFatigueHealRunning"
	sRightPaneHealHints[2] = "$RRhintFatigueHealSneaking"
	sRightPaneHealHints[3] = "$RRhintFatigueHealWalking"

	; Magicka

	sRightPaneMagickaIndexList = new GlobalVariable[4]
	sRightPaneMagickaIndexList[0] = RRRelaxArrowMagickaEnabled
	sRightPaneMagickaIndexList[1] = RRRelaxRunningMagickaEnabled
	sRightPaneMagickaIndexList[2] = RRRelaxStealthMagickaEnabled
	sRightPaneMagickaIndexList[3] = RRRelaxWalkingMagickaEnabled

	sRightPaneMagickaValueList = new GlobalVariable[4]
	sRightPaneMagickaValueList[0] = RRRelaxArrowMagickaValue
	sRightPaneMagickaValueList[1] = RRRelaxRunningMagickaValue
	sRightPaneMagickaValueList[2] = RRRelaxStealthMagickaValue
	sRightPaneMagickaValueList[3] = RRRelaxWalkingMagickaValue

	iRightPaneMagickaFlags = new int[4]
	iRightPaneMagickaFlags[0] = OPTION_FLAG_NONE
	iRightPaneMagickaFlags[1] = OPTION_FLAG_NONE
	iRightPaneMagickaFlags[2] = OPTION_FLAG_NONE
	iRightPaneMagickaFlags[3] = OPTION_FLAG_NONE

	sRightPaneMagickaHints = new string[4]
	sRightPaneMagickaHints[0] = "$RRhintFatigueMagickaNock"
	sRightPaneMagickaHints[1] = "$RRhintFatigueMagickaRunning"
	sRightPaneMagickaHints[2] = "$RRhintFatigueMagickaSneaking"
	sRightPaneMagickaHints[3] = "$RRhintFatigueMagickaWalking"

	; Stamina

	sRightPaneStaminaIndexList = new GlobalVariable[4]
	sRightPaneStaminaIndexList[0] = RRRelaxArrowStaminaEnabled
	sRightPaneStaminaIndexList[1] = RRRelaxRunningStaminaEnabled
	sRightPaneStaminaIndexList[2] = RRRelaxStealthStaminaEnabled
	sRightPaneStaminaIndexList[3] = RRRelaxWalkingStaminaEnabled

	sRightPaneStaminaValueList = new GlobalVariable[4]
	sRightPaneStaminaValueList[0] = RRRelaxArrowStaminaValue
	sRightPaneStaminaValueList[1] = RRRelaxRunningStaminaValue
	sRightPaneStaminaValueList[2] = RRRelaxStealthStaminaValue
	sRightPaneStaminaValueList[3] = RRRelaxWalkingStaminaValue

	iRightPaneStaminaFlags = new int[4]
	iRightPaneStaminaFlags[0] = OPTION_FLAG_NONE
	iRightPaneStaminaFlags[1] = OPTION_FLAG_NONE
	iRightPaneStaminaFlags[2] = OPTION_FLAG_NONE
	iRightPaneStaminaFlags[3] = OPTION_FLAG_NONE

	sRightPaneStaminaHints = new string[4]
	sRightPaneStaminaHints[0] = "$RRhintFatigueStaminaNock"
	sRightPaneStaminaHints[1] = "$RRhintFatigueStaminaRunning"
	sRightPaneStaminaHints[2] = "$RRhintFatigueStaminaSneaking"
	sRightPaneStaminaHints[3] = "$RRhintFatigueStaminaWalking"
EndFunction

Function updateCourageAndFatigueFlags()
	if ( updateModEnabledFlags() )
		updateLeftPaneFlags()
		updateRightPaneFlags()
	else
		disableAllFlags()
		disableLeftPaneFlags()
		disableRightPaneFlags()
	endIf
EndFunction

Function updateLeftPaneFlags()
	int iIndex = 0
	while ( iIndex < iLeftPaneHealFlags.Length )
		if ( sLeftPaneHealIndexList[iIndex].GetValueInt() == 1 )
			iLeftPaneHealFlags[iIndex] = OPTION_FLAG_NONE
		else
			iLeftPaneHealFlags[iIndex] = OPTION_FLAG_DISABLED
		endIf

		if ( sLeftPaneMagickaIndexList[iIndex].GetValueInt() == 1 )
			iLeftPaneMagickaFlags[iIndex] = OPTION_FLAG_NONE
		else
			iLeftPaneMagickaFlags[iIndex] = OPTION_FLAG_DISABLED
		endIf

		if ( sLeftPaneStaminaIndexList[iIndex].GetValueInt() == 1 )
			iLeftPaneStaminaFlags[iIndex] = OPTION_FLAG_NONE
		else
			iLeftPaneStaminaFlags[iIndex] = OPTION_FLAG_DISABLED
		endIf

		iIndex += 1
	endWhile
EndFunction

Function updateRightPaneFlags()
	int iIndex = 0
	while ( iIndex < iRightPaneHealFlags.Length )
		if ( sRightPaneHealIndexList[iIndex].GetValueInt() == 1 )
			iRightPaneHealFlags[iIndex] = OPTION_FLAG_NONE
		else
			iRightPaneHealFlags[iIndex] = OPTION_FLAG_DISABLED
		endIf

		if ( sRightPaneMagickaIndexList[iIndex].GetValueInt() == 1 )
			iRightPaneMagickaFlags[iIndex] = OPTION_FLAG_NONE
		else
			iRightPaneMagickaFlags[iIndex] = OPTION_FLAG_DISABLED
		endIf

		if ( sRightPaneStaminaIndexList[iIndex].GetValueInt() == 1 )
			iRightPaneStaminaFlags[iIndex] = OPTION_FLAG_NONE
		else
			iRightPaneStaminaFlags[iIndex] = OPTION_FLAG_DISABLED
		endIf

		iIndex += 1
	endWhile
EndFunction

Function disableLeftPaneFlags()
	int iIndex = 0
	while ( iIndex < iLeftPaneHealFlags.Length )
		iLeftPaneHealFlags[iIndex] = OPTION_FLAG_DISABLED
		iLeftPaneMagickaFlags[iIndex] = OPTION_FLAG_DISABLED
		iLeftPaneStaminaFlags[iIndex] = OPTION_FLAG_DISABLED

		iIndex += 1
	endWhile
EndFunction

Function disableRightPaneFlags()
	int iIndex = 0
	while ( iIndex < iRightPaneHealFlags.Length )
		iRightPaneHealFlags[iIndex] = OPTION_FLAG_DISABLED
		iRightPaneMagickaFlags[iIndex] = OPTION_FLAG_DISABLED
		iRightPaneStaminaFlags[iIndex] = OPTION_FLAG_DISABLED

		iIndex += 1
	endWhile
EndFunction


Function LeftPaneShowcase()
	updateCourageAndFatigueFlags()

	iLeftPane += 1

	if ( iLeftPane >= sLeftPaneHeaderList.Length )
		iLeftPane = 0
	endIf

	SetTextOptionValueST( sLeftPaneHeaderList[iLeftPane], false, "LEFT_PANE" )

	int iEnabled = sLeftPaneHealIndexList[iLeftPane].GetValueInt()
	float fValue = sLeftPaneHealValueList[iLeftPane].GetValue()
	int iFlag = iLeftPaneHealFlags[iLeftPane]

	SetToggleOptionValueST( iEnabled, false, "LEFT_HEAL_ENABLED" )
	SetSliderOptionValueST( fValue, _sliderFS, false, "LEFT_HEAL_VALUE" )
	SetOptionFlagsST( iFlag, false, "LEFT_HEAL_VALUE" )

	iEnabled = sLeftPaneMagickaIndexList[iLeftPane].GetValueInt()
	fValue = sLeftPaneMagickaValueList[iLeftPane].GetValue()
	iFlag = iLeftPaneMagickaFlags[iLeftPane]

	SetToggleOptionValueST( iEnabled, false, "LEFT_MAGICKA_ENABLED" )
	SetSliderOptionValueST( fValue, _sliderFS, false, "LEFT_MAGICKA_VALUE" )
	SetOptionFlagsST( iFlag, false, "LEFT_MAGICKA_VALUE" )

	iEnabled = sLeftPaneStaminaIndexList[iLeftPane].GetValueInt()
	fValue = sLeftPaneStaminaValueList[iLeftPane].GetValue()
	iFlag = iLeftPaneStaminaFlags[iLeftPane]

	SetToggleOptionValueST( iEnabled, false, "LEFT_STAMINA_ENABLED" )
	SetSliderOptionValueST( fValue, _sliderFS, false, "LEFT_STAMINA_VALUE" )
	SetOptionFlagsST( iFlag, false, "LEFT_STAMINA_VALUE" )
EndFunction

Function RightPaneShowcase()
	updateCourageAndFatigueFlags()

	iRightPane += 1

	if ( iRightPane >= sRightPaneHeaderList.Length )
		iRightPane = 0
	endIf

	SetTextOptionValueST( sRightPaneHeaderList[iRightPane], false, "RIGHT_PANE" )

	int iEnabled = sRightPaneHealIndexList[iRightPane].GetValueInt()
	float fValue = sRightPaneHealValueList[iRightPane].GetValue()
	int iFlag = iRightPaneHealFlags[iRightPane]

	SetToggleOptionValueST( iEnabled, false, "RIGHT_HEAL_ENABLED" )
	SetSliderOptionValueST( fValue, _sliderFS, false, "RIGHT_HEAL_VALUE" )
	SetOptionFlagsST( iFlag, false, "RIGHT_HEAL_VALUE" )

	iEnabled = sRightPaneMagickaIndexList[iRightPane].GetValueInt()
	fValue = sRightPaneMagickaValueList[iRightPane].GetValue()
	iFlag = iRightPaneMagickaFlags[iRightPane]

	SetToggleOptionValueST( iEnabled, false, "RIGHT_MAGICKA_ENABLED" )
	SetSliderOptionValueST( fValue, _sliderFS, false, "RIGHT_MAGICKA_VALUE" )
	SetOptionFlagsST( iFlag, false, "RIGHT_MAGICKA_VALUE" )

	iEnabled = sRightPaneStaminaIndexList[iRightPane].GetValueInt()
	fValue = sRightPaneStaminaValueList[iRightPane].GetValue()
	iFlag = iRightPaneStaminaFlags[iRightPane]

	SetToggleOptionValueST( iEnabled, false, "RIGHT_STAMINA_ENABLED" )
	SetSliderOptionValueST( fValue, _sliderFS, false, "RIGHT_STAMINA_VALUE" )
	SetOptionFlagsST( iFlag, false, "RIGHT_STAMINA_VALUE" )
EndFunction

Function updateLeftPaneOption( string sName )
	if ( sName == "Heal" )
		if ( sLeftPaneHealIndexList[iLeftPane].GetValueInt() == 1 )
			iLeftPaneHealFlags[iLeftPane] = OPTION_FLAG_NONE
		else
			iLeftPaneHealFlags[iLeftPane] = OPTION_FLAG_DISABLED
		endIf

		SetOptionFlagsST( iLeftPaneHealFlags[iLeftPane], false, "LEFT_HEAL_VALUE" )
	elseif ( sName == "Magicka" )
		if ( sLeftPaneMagickaIndexList[iLeftPane].GetValueInt() == 1 )
			iLeftPaneMagickaFlags[iLeftPane] = OPTION_FLAG_NONE
		else
			iLeftPaneMagickaFlags[iLeftPane] = OPTION_FLAG_DISABLED
		endIf

		SetOptionFlagsST( iLeftPaneMagickaFlags[iLeftPane], false, "LEFT_MAGICKA_VALUE" )
	elseif ( sName == "Stamina" )
		if ( sLeftPaneStaminaIndexList[iLeftPane].GetValueInt() == 1 )
			iLeftPaneStaminaFlags[iLeftPane] = OPTION_FLAG_NONE
		else
			iLeftPaneStaminaFlags[iLeftPane] = OPTION_FLAG_DISABLED
		endIf

		SetOptionFlagsST( iLeftPaneStaminaFlags[iLeftPane], false, "LEFT_STAMINA_VALUE" )
	else
		return
	endIf
EndFunction

Function updateRightPaneOption( string sName )
	if ( sName == "Heal" )
		if ( sRightPaneHealIndexList[iRightPane].GetValueInt() == 1 )
			iRightPaneHealFlags[iRightPane] = OPTION_FLAG_NONE
		else
			iRightPaneHealFlags[iRightPane] = OPTION_FLAG_DISABLED
		endIf

		SetOptionFlagsST( iRightPaneHealFlags[iRightPane], false, "RIGHT_HEAL_VALUE" )
	elseif ( sName == "Magicka" )
		if ( sRightPaneMagickaIndexList[iRightPane].GetValueInt() == 1 )
			iRightPaneMagickaFlags[iRightPane] = OPTION_FLAG_NONE
		else
			iRightPaneMagickaFlags[iRightPane] = OPTION_FLAG_DISABLED
		endIf

		SetOptionFlagsST( iRightPaneMagickaFlags[iRightPane], false, "RIGHT_MAGICKA_VALUE" )
	elseif ( sName == "Stamina" )
		if ( sRightPaneStaminaIndexList[iRightPane].GetValueInt() == 1 )
			iRightPaneStaminaFlags[iRightPane] = OPTION_FLAG_NONE
		else
			iRightPaneStaminaFlags[iRightPane] = OPTION_FLAG_DISABLED
		endIf

		SetOptionFlagsST( iRightPaneStaminaFlags[iRightPane], false, "RIGHT_STAMINA_VALUE" )
	else
		return
	endIf
EndFunction

;
; PAGE Boosters -----------------------------------------------------------------------------------
;

Function generateCourageAndFatiguePage()
	SetCursorFillMode(TOP_TO_BOTTOM)

	AddHeaderOption( "$RRCourage" )
	AddTextOptionST( "LEFT_PANE", "$RRClickMe", sLeftPaneHeaderList[iLeftPane], _modEnabledFlags )
	AddEmptyOption()

	int iEnabled = sLeftPaneHealIndexList[iLeftPane].GetValueInt()
	float fValue = sLeftPaneHealValueList[iLeftPane].GetValue()
	int iFlag = iLeftPaneHealFlags[iLeftPane]

	AddToggleOptionST( "LEFT_HEAL_ENABLED", "$Health", iEnabled, _modEnabledFlags)
	AddSliderOptionST( "LEFT_HEAL_VALUE", "$Value", fValue, _sliderFS, iFlag )
	AddEmptyOption()

	iEnabled = sLeftPaneMagickaIndexList[iLeftPane].GetValueInt()
	fValue = sLeftPaneMagickaValueList[iLeftPane].GetValue()
	iFlag = iLeftPaneMagickaFlags[iLeftPane]

	AddToggleOptionST( "LEFT_MAGICKA_ENABLED", "$Magicka", iEnabled, _modEnabledFlags)
	AddSliderOptionST( "LEFT_MAGICKA_VALUE", "$Value", fValue, _sliderFS, iFlag )
	AddEmptyOption()

	iEnabled = sLeftPaneStaminaIndexList[iLeftPane].GetValueInt()
	fValue = sLeftPaneStaminaValueList[iLeftPane].GetValue()
	iFlag = iLeftPaneStaminaFlags[iLeftPane]

	AddToggleOptionST( "LEFT_STAMINA_ENABLED", "$Stamina", iEnabled, _modEnabledFlags)
	AddSliderOptionST( "LEFT_STAMINA_VALUE", "$Value", fValue, _sliderFS, iFlag )


	SetCursorPosition(1)

	AddHeaderOption( "$RRFatigue" )
	AddTextOptionST( "RIGHT_PANE", "$RRClickMe", sRightPaneHeaderList[iRightPane], _modEnabledFlags )
	AddEmptyOption()

	iEnabled = sRightPaneHealIndexList[iRightPane].GetValueInt()
	fValue = sRightPaneHealValueList[iRightPane].GetValue()
	iFlag = iRightPaneHealFlags[iRightPane]

	AddToggleOptionST( "RIGHT_HEAL_ENABLED", "$Health", iEnabled, _modEnabledFlags)
	AddSliderOptionST( "RIGHT_HEAL_VALUE", "$Value", fValue, _sliderFS, iFlag )
	AddEmptyOption()

	iEnabled = sRightPaneMagickaIndexList[iRightPane].GetValueInt()
	fValue = sRightPaneMagickaValueList[iRightPane].GetValue()
	iFlag = iRightPaneMagickaFlags[iRightPane]

	AddToggleOptionST( "RIGHT_MAGICKA_ENABLED", "$Magicka", iEnabled, _modEnabledFlags)
	AddSliderOptionST( "RIGHT_MAGICKA_VALUE", "$Value", fValue, _sliderFS, iFlag )
	AddEmptyOption()

	iEnabled = sRightPaneStaminaIndexList[iRightPane].GetValueInt()
	fValue = sRightPaneStaminaValueList[iRightPane].GetValue()
	iFlag = iRightPaneStaminaFlags[iRightPane]

	AddToggleOptionST( "RIGHT_STAMINA_ENABLED", "$Stamina", iEnabled, _modEnabledFlags)
	AddSliderOptionST( "RIGHT_STAMINA_VALUE", "$Value", fValue, _sliderFS, iFlag )
EndFunction


;
; STATE Boosters ----------------------------------------------------------------------------------
;

State LEFT_PANE ; TEXT
	event OnSelectST()
		LeftPaneShowcase()
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintBoosterPane")
	endEvent
EndState

state LEFT_HEAL_ENABLED ; TOGGLE
	event onSelectST()
		RRSkyUILib.toggle( sLeftPaneHealIndexList[iLeftPane] )
		SetToggleOptionValueST( sLeftPaneHealIndexList[iLeftPane].GetValueInt() )
		updateLeftPaneOption( "Heal" )
	endEvent

	event OnHighlightST()
		SetInfoText( sLeftPaneHealHints[iLeftPane] )
	endEvent
endState

state LEFT_MAGICKA_ENABLED ; TOGGLE
	event onSelectST()
		RRSkyUILib.toggle( sLeftPaneMagickaIndexList[iLeftPane] )
		SetToggleOptionValueST( sLeftPaneMagickaIndexList[iLeftPane].GetValueInt() )
		updateLeftPaneOption( "Magicka" )
	endEvent

	event OnHighlightST()
		SetInfoText( sLeftPaneMagickaHints[iLeftPane] )
	endEvent
endState

state LEFT_STAMINA_ENABLED ; TOGGLE
	event onSelectST()
		RRSkyUILib.toggle( sLeftPaneStaminaIndexList[iLeftPane] )
		SetToggleOptionValueST( sLeftPaneStaminaIndexList[iLeftPane].GetValueInt() )
		updateLeftPaneOption( "Stamina" )
	endEvent

	event OnHighlightST()
		SetInfoText( sLeftPaneStaminaHints[iLeftPane] )
	endEvent
endState


state LEFT_HEAL_VALUE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( sLeftPaneHealValueList[iLeftPane].GetValue() )
		SetSliderDialogDefaultValue( 0.0 )
		SetSliderDialogRange( fCourageMin, fCourageMax )
		SetSliderDialogInterval( fCourageInterval )
	endEvent

	event OnSliderAcceptST( float value )
		sLeftPaneHealValueList[iLeftPane].SetValue( value )
		SetSliderOptionValueST( sLeftPaneHealValueList[iLeftPane].GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		sLeftPaneHealValueList[iLeftPane].SetValue( 0.0 )
		SetSliderOptionValueST( sLeftPaneHealValueList[iLeftPane].GetValue(), _sliderFS )
	endEvent
endState

state LEFT_MAGICKA_VALUE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( sLeftPaneMagickaValueList[iLeftPane].GetValue() )
		SetSliderDialogDefaultValue( 0.0 )
		SetSliderDialogRange( fCourageMin, fCourageMax )
		SetSliderDialogInterval( fCourageInterval )
	endEvent

	event OnSliderAcceptST( float value )
		sLeftPaneMagickaValueList[iLeftPane].SetValue( value )
		SetSliderOptionValueST( sLeftPaneMagickaValueList[iLeftPane].GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		sLeftPaneMagickaValueList[iLeftPane].SetValue( 0.0 )
		SetSliderOptionValueST( sLeftPaneMagickaValueList[iLeftPane].GetValue(), _sliderFS )
	endEvent
endState

state LEFT_STAMINA_VALUE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( sLeftPaneStaminaValueList[iLeftPane].GetValue() )
		SetSliderDialogDefaultValue( 0.0 )
		SetSliderDialogRange( fCourageMin, fCourageMax )
		SetSliderDialogInterval( fCourageInterval )
	endEvent

	event OnSliderAcceptST( float value )
		sLeftPaneStaminaValueList[iLeftPane].SetValue( value )
		SetSliderOptionValueST( sLeftPaneStaminaValueList[iLeftPane].GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		sLeftPaneStaminaValueList[iLeftPane].SetValue( 0.0 )
		SetSliderOptionValueST( sLeftPaneStaminaValueList[iLeftPane].GetValue(), _sliderFS )
	endEvent
endState



State RIGHT_PANE ; TEXT
	event OnSelectST()
		RightPaneShowcase()
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintBoosterPane")
	endEvent
EndState

state RIGHT_HEAL_ENABLED ; TOGGLE
	event onSelectST()
		RRSkyUILib.toggle( sRightPaneHealIndexList[iRightPane] )
		SetToggleOptionValueST( sRightPaneHealIndexList[iRightPane].GetValueInt() )
		updateRightPaneOption( "Heal" )
	endEvent

	event OnHighlightST()
		SetInfoText( sRightPaneHealHints[iRightPane] )
	endEvent
endState

state RIGHT_MAGICKA_ENABLED ; TOGGLE
	event onSelectST()
		RRSkyUILib.toggle( sRightPaneMagickaIndexList[iRightPane] )
		SetToggleOptionValueST( sRightPaneMagickaIndexList[iRightPane].GetValueInt() )
		updateRightPaneOption( "Magicka" )
	endEvent

	event OnHighlightST()
		SetInfoText( sRightPaneMagickaHints[iRightPane] )
	endEvent
endState

state RIGHT_STAMINA_ENABLED ; TOGGLE
	event onSelectST()
		RRSkyUILib.toggle( sRightPaneStaminaIndexList[iRightPane] )
		SetToggleOptionValueST( sRightPaneStaminaIndexList[iRightPane].GetValueInt() )
		updateRightPaneOption( "Stamina" )
	endEvent

	event OnHighlightST()
		SetInfoText( sRightPaneStaminaHints[iRightPane] )
	endEvent
endState


state RIGHT_HEAL_VALUE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( sRightPaneHealValueList[iRightPane].GetValue() )
		SetSliderDialogDefaultValue( 0.0 )
		SetSliderDialogRange( fCourageMin, fCourageMax )
		SetSliderDialogInterval( fFatigueInterval )
	endEvent

	event OnSliderAcceptST( float value )
		sRightPaneHealValueList[iRightPane].SetValue( value )
		SetSliderOptionValueST( sRightPaneHealValueList[iRightPane].GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		sRightPaneHealValueList[iRightPane].SetValue( 0.0 )
		SetSliderOptionValueST( sRightPaneHealValueList[iRightPane].GetValue(), _sliderFS )
	endEvent
endState

state RIGHT_MAGICKA_VALUE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( sRightPaneMagickaValueList[iRightPane].GetValue() )
		SetSliderDialogDefaultValue( 0.0 )
		SetSliderDialogRange( fCourageMin, fCourageMax )
		SetSliderDialogInterval( fFatigueInterval )
	endEvent

	event OnSliderAcceptST( float value )
		sRightPaneMagickaValueList[iRightPane].SetValue( value )
		SetSliderOptionValueST( sRightPaneMagickaValueList[iRightPane].GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		sRightPaneMagickaValueList[iRightPane].SetValue( 0.0 )
		SetSliderOptionValueST( sRightPaneMagickaValueList[iRightPane].GetValue(), _sliderFS )
	endEvent
endState

state RIGHT_STAMINA_VALUE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( sRightPaneStaminaValueList[iRightPane].GetValue() )
		SetSliderDialogDefaultValue( 0.0 )
		SetSliderDialogRange( fCourageMin, fCourageMax )
		SetSliderDialogInterval( fFatigueInterval )
	endEvent

	event OnSliderAcceptST( float value )
		sRightPaneStaminaValueList[iRightPane].SetValue( value )
		SetSliderOptionValueST( sRightPaneStaminaValueList[iRightPane].GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		sRightPaneStaminaValueList[iRightPane].SetValue( 0.0 )
		SetSliderOptionValueST( sRightPaneStaminaValueList[iRightPane].GetValue(), _sliderFS )
	endEvent
endState
