Scriptname RRConfigCombatScript extends RRConfigBeastFormScript Hidden 
{Realistic Regeneration for SkyUI : Combat Page}

; +-RRSkyUIConfigParentScript
; +-+-RRConfigHelpScript
;   +-+-RRConfigSlidersScript
;     +-+-RRConfigTemplatesScript
;       +-+-RRConfigMiscScript
;         +-+-RRConfigBeastFormScript
;           +-+-RRConfigCombatScript
;             +-+-RRConfigBoostersScript
;               +-+-RRConfigAttributesScript
;                 +-+-RRSkyUIConfigMenuScript

;
; PAGE Combat -------------------------------------------------------------------------------------
;

Function generateCombatPage()
	SetCursorFillMode(TOP_TO_BOTTOM)

	AddHeaderOption("$RRCombatMultipliers", _modEnabledFlags)
	AddEmptyOption()

	int rIndex = RRCombatMultHealIndex.GetValueInt()
	string rName = _defaultOptionsList[rIndex]
	float rValue = RRSkyUILib.getRRCVMult( rIndex, RRCombatMultHealValue, "Health" )

	AddMenuOptionST("COMBAT_MULT_HEAL_TYPE", "$Health", rName, _modHealFlags)
	AddSliderOptionST("COMBAT_MULT_HEAL_VALUE", "$Value", rValue, _sliderFS, _combatMultHealFlags)
	AddEmptyOption()

	rIndex = RRCombatMultMagickaIndex.GetValueInt()
	rName = _commonOptionsList[rIndex]
	rValue = RRSkyUILib.getRRCVMult( rIndex, RRCombatMultMagickaValue, "Magicka" )

	AddMenuOptionST("COMBAT_MULT_MAGICKA_TYPE", "$Magicka", rName, _modMagickaFlags)
	AddSliderOptionST("COMBAT_MULT_MAGICKA_VALUE", "$Value", rValue, _sliderFS, _combatMultMagickaFlags)
	AddEmptyOption()

	rIndex = RRCombatMultStaminaIndex.GetValueInt()
	rName = _commonOptionsList[rIndex]
	rValue = RRSkyUILib.getRRCVMult( rIndex, RRCombatMultStaminaValue, "Stamina" )

	AddMenuOptionST("COMBAT_MULT_STAMINA_TYPE", "$Stamina", rName, _modStaminaFlags)
	AddSliderOptionST("COMBAT_MULT_STAMINA_VALUE", "$Value", rValue, _sliderFS, _combatMultStaminaFlags)

	SetCursorPosition(1)

	AddHeaderOption("$RRCombatSettings", _modEnabledFlags)
	AddEmptyOption()

	rIndex = RRCombatHealIndex.GetValueInt()
	rName = _commonOptionsList[rIndex]
	rValue = RRSkyUILib.getRRCV( rIndex, RRCombatHealValue, "Health" )

	AddMenuOptionST("COMBAT_HEAL_TYPE", "$Health", rName, _modHealFlags)
	AddSliderOptionST("COMBAT_HEAL_VALUE", "$Value", rValue, _sliderFS, _combatHealFlags)
	AddEmptyOption()

	rIndex = RRCombatMagickaIndex.GetValueInt()
	rName = _commonOptionsList[rIndex]
	rValue = RRSkyUILib.getRRCV( rIndex, RRCombatMagickaValue, "Magicka" )

	AddMenuOptionST("COMBAT_MAGICKA_TYPE", "$Magicka", rName, _modMagickaFlags)
	AddSliderOptionST("COMBAT_MAGICKA_VALUE", "$Value", rValue, _sliderFS, _combatMagickaFlags)
	AddEmptyOption()

	rIndex = RRCombatStaminaIndex.GetValueInt()
	rName = _commonOptionsList[rIndex]
	rValue = RRSkyUILib.getRRCV( rIndex, RRCombatStaminaValue, "Stamina" )

	AddMenuOptionST("COMBAT_STAMINA_TYPE", "$Stamina", rName, _modStaminaFlags)
	AddSliderOptionST("COMBAT_STAMINA_VALUE", "$Value", rValue, _sliderFS, _combatStaminaFlags)
endFunction

;
; STATE Combat ------------------------------------------------------------------------------------
;
; STATE Combat : Menus ----------------------------------------------------------------------------
;

state COMBAT_MULT_HEAL_TYPE ; MENU
	event OnMenuOpenST()
		SetMenuDialogStartIndex(RRCombatMultHealIndex.GetValueInt())
		SetMenuDialogDefaultIndex(RRFunctionDefault.GetValueInt())
		SetMenuDialogOptions(_defaultOptionsList)
	endEvent

	event OnMenuAcceptST(int index)
		RRCombatMultHealIndex.SetValueInt(index)
		updateCombatFlags()
		updateCombatSliderOption(RRCombatMultHealIndex, RRCombatMultHealValue, "Health", "COMBAT_MULT_HEAL_VALUE", _combatMultHealFlags, _defaultOptionsList)
	endEvent

	event OnDefaultST()
		RRCombatMultHealIndex.SetValueInt(1)
		updateCombatFlags()
		updateCombatSliderOption(RRCombatMultHealIndex, RRCombatMultHealValue, "Health", "COMBAT_MULT_HEAL_VALUE", _combatMultHealFlags, _defaultOptionsList)
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintCombatMultType")
	endEvent
endState

state COMBAT_MULT_MAGICKA_TYPE ; MENU
	event OnMenuOpenST()
		SetMenuDialogStartIndex(RRCombatMultMagickaIndex.GetValueInt())
		SetMenuDialogDefaultIndex(RRFunctionDefault.GetValueInt())
		SetMenuDialogOptions(_defaultOptionsList)
	endEvent

	event OnMenuAcceptST(int index)
		RRCombatMultMagickaIndex.SetValueInt(index)
		updateCombatFlags()
		updateCombatSliderOption(RRCombatMultMagickaIndex, RRCombatMultMagickaValue, "Magicka", "COMBAT_MULT_MAGICKA_VALUE", _combatMultMagickaFlags, _defaultOptionsList)
	endEvent

	event OnDefaultST()
		RRCombatMultMagickaIndex.SetValueInt(1)
		updateCombatFlags()
		updateCombatSliderOption(RRCombatMultMagickaIndex, RRCombatMultMagickaValue, "Magicka", "COMBAT_MULT_MAGICKA_VALUE", _combatMultMagickaFlags, _defaultOptionsList)
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintCombatMultType")
	endEvent
endState

state COMBAT_MULT_STAMINA_TYPE ; MENU
	event OnMenuOpenST()
		SetMenuDialogStartIndex(RRCombatMultStaminaIndex.GetValueInt())
		SetMenuDialogDefaultIndex(RRFunctionDefault.GetValueInt())
		SetMenuDialogOptions(_defaultOptionsList)
	endEvent

	event OnMenuAcceptST(int index)
		RRCombatMultStaminaIndex.SetValueInt(index)
		updateCombatFlags()
		updateCombatSliderOption(RRCombatMultStaminaIndex, RRCombatMultStaminaValue, "Stamina", "COMBAT_MULT_STAMINA_VALUE", _combatMultStaminaFlags, _defaultOptionsList)
	endEvent

	event OnDefaultST()
		RRCombatMultStaminaIndex.SetValueInt(1)
		updateCombatFlags()
		updateCombatSliderOption(RRCombatMultStaminaIndex, RRCombatMultStaminaValue, "Stamina", "COMBAT_MULT_STAMINA_VALUE", _combatMultStaminaFlags, _defaultOptionsList)
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintCombatMultType")
	endEvent
endState

state COMBAT_HEAL_TYPE ; MENU
	event OnMenuOpenST()
		SetMenuDialogStartIndex(RRCombatHealIndex.GetValueInt())
		SetMenuDialogDefaultIndex(RRFunctionDefault.GetValueInt())
		SetMenuDialogOptions(_commonOptionsList)
	endEvent

	event OnMenuAcceptST(int index)
		RRCombatHealIndex.SetValueInt(index)
		updateCombatFlags()
		updateSliderOption(RRCombatHealIndex, RRCombatHealValue, "Health", "COMBAT_HEAL_VALUE", _combatHealFlags, _commonOptionsList)
	endEvent

	event OnDefaultST()
		RRCombatHealIndex.SetValueInt(RRFunctionDefault.GetValueInt())
		updateCombatFlags()
		updateSliderOption(RRCombatHealIndex, RRCombatHealValue, "Health", "COMBAT_HEAL_VALUE", _combatHealFlags, _commonOptionsList)
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintType")
	endEvent
endState

state COMBAT_MAGICKA_TYPE ; MENU
	event OnMenuOpenST()
		SetMenuDialogStartIndex(RRCombatMagickaIndex.GetValueInt())
		SetMenuDialogDefaultIndex(RRFunctionDefault.GetValueInt())
		SetMenuDialogOptions(_commonOptionsList)
	endEvent

	event OnMenuAcceptST(int index)
		RRCombatMagickaIndex.SetValueInt(index)
		updateCombatFlags()
		updateSliderOption(RRCombatMagickaIndex, RRCombatMagickaValue, "Magicka", "COMBAT_MAGICKA_VALUE", _combatMagickaFlags, _commonOptionsList)
	endEvent

	event OnDefaultST()
		RRCombatMagickaIndex.SetValueInt(RRFunctionDefault.GetValueInt())
		updateCombatFlags()
		updateSliderOption(RRCombatMagickaIndex, RRCombatMagickaValue, "Magicka", "COMBAT_MAGICKA_VALUE", _combatMagickaFlags, _commonOptionsList)
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintType")
	endEvent
endState

state COMBAT_STAMINA_TYPE ; MENU
	event OnMenuOpenST()
		SetMenuDialogStartIndex(RRCombatStaminaIndex.GetValueInt())
		SetMenuDialogDefaultIndex(RRFunctionDefault.GetValueInt())
		SetMenuDialogOptions(_commonOptionsList)
	endEvent

	event OnMenuAcceptST(int index)
		RRCombatStaminaIndex.SetValueInt(index)
		updateCombatFlags()
		updateSliderOption(RRCombatStaminaIndex, RRCombatStaminaValue, "Stamina", "COMBAT_STAMINA_VALUE", _combatStaminaFlags, _commonOptionsList)
	endEvent

	event OnDefaultST()
		RRCombatStaminaIndex.SetValueInt(RRFunctionDefault.GetValueInt())
		updateCombatFlags()
		updateSliderOption(RRCombatStaminaIndex, RRCombatStaminaValue, "Stamina", "COMBAT_STAMINA_VALUE", _combatStaminaFlags, _commonOptionsList)
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintType")
	endEvent
endState

;
; STATE Combat : Sliders ------------------------------------------------------------------
;

state COMBAT_MULT_HEAL_VALUE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue(  RRCombatMultHealValue.GetValue() )
		SetSliderDialogDefaultValue( _defaultCombatHealMultValue )
		SetSliderDialogRange( RRsliderCMHealMin.GetValue(), RRsliderCMHealMax.GetValue() )
		SetSliderDialogInterval( RRsliderCMHealInterval.GetValue() )
	endEvent

	event OnDefaultST()
		RRCombatMultHealValue.SetValue(_defaultCombatHealMultValue)
		SetSliderOptionValueST( RRCombatMultHealValue.GetValue(), _sliderFS )
	endEvent

	event OnSliderAcceptST( float value )
		RRCombatMultHealValue.SetValue( value )
		SetSliderOptionValueST( RRCombatMultHealValue.GetValue(), _sliderFS )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintCombatMultValue" )
	endEvent
endState

state COMBAT_MULT_MAGICKA_VALUE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRCombatMultMagickaValue.GetValue() )
		SetSliderDialogDefaultValue( _defaultCombatMagickaMultValue )
		SetSliderDialogRange( RRsliderCMMagickaMin.GetValue(), RRsliderCMMagickaMax.GetValue() )
		SetSliderDialogInterval( RRsliderCMMagickaInterval.GetValue() )
	endEvent

	event OnDefaultST()
		RRCombatMultMagickaValue.SetValue( _defaultCombatMagickaMultValue )
		SetSliderOptionValueST( RRCombatMultMagickaValue.GetValue(), _sliderFS )
	endEvent

	event OnSliderAcceptST( float value )
		RRCombatMultMagickaValue.SetValue( value )
		SetSliderOptionValueST( RRCombatMultMagickaValue.GetValue(), _sliderFS )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintCombatMultValue" )
	endEvent
endState

state COMBAT_MULT_STAMINA_VALUE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRCombatMultStaminaValue.GetValue() )
		SetSliderDialogDefaultValue( _defaultCombatStaminaMultValue )
		SetSliderDialogRange( RRsliderCMStaminaMin.GetValue(), RRsliderCMStaminaMax.GetValue() )
		SetSliderDialogInterval( RRsliderCMStaminaInterval.GetValue() )
	endEvent

	event OnDefaultST()
		RRCombatMultStaminaValue.SetValue( _defaultCombatStaminaMultValue )
		SetSliderOptionValueST( RRCombatMultStaminaValue.GetValue(), _sliderFS )
	endEvent

	event OnSliderAcceptST( float value )
		RRCombatMultStaminaValue.SetValue( value )
		SetSliderOptionValueST( RRCombatMultStaminaValue.GetValue(), _sliderFS )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintCombatMultValue" )
	endEvent
endState


state COMBAT_HEAL_VALUE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRCombatHealValue.GetValue() )
		SetSliderDialogDefaultValue( _defaultHealRateValue )
		SetSliderDialogRange( RRsliderHealMin.GetValue(), RRsliderHealMax.GetValue() )
		SetSliderDialogInterval( RRsliderHealInterval.GetValue() )
	endEvent

	event OnDefaultST()
		RRCombatHealValue.SetValue( _defaultHealRateValue )
		SetSliderOptionValueST( RRCombatHealValue.GetValue(), _sliderFS )
	endEvent

	event OnSliderAcceptST( float value )
		RRCombatHealValue.SetValue( value )
		SetSliderOptionValueST( RRCombatHealValue.GetValue(), _sliderFS )
	endEvent
endState

state COMBAT_MAGICKA_VALUE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRCombatMagickaValue.GetValue() )
		SetSliderDialogDefaultValue( _defaultMagickaRateValue )
		SetSliderDialogRange( RRsliderMagickaMin.GetValue(), RRsliderMagickaMax.GetValue() )
		SetSliderDialogInterval( RRsliderMagickaInterval.GetValue() )
	endEvent

	event OnDefaultST()
		RRCombatMagickaValue.SetValue( _defaultMagickaRateValue )
		SetSliderOptionValueST( RRCombatMagickaValue.GetValue(), _sliderFS )
	endEvent

	event OnSliderAcceptST( float value )
		RRCombatMagickaValue.SetValue( value )
		SetSliderOptionValueST( RRCombatMagickaValue.GetValue(), _sliderFS )
	endEvent
endState

state COMBAT_STAMINA_VALUE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRCombatStaminaValue.GetValue() )
		SetSliderDialogDefaultValue( _defaultStaminaRateValue )
		SetSliderDialogRange( RRsliderStaminaMin.GetValue(), RRsliderStaminaMax.GetValue() )
		SetSliderDialogInterval( RRsliderStaminaInterval.GetValue() )
	endEvent

	event OnDefaultST()
		RRCombatStaminaValue.SetValue( _defaultStaminaRateValue )
		SetSliderOptionValueST( RRCombatStaminaValue.GetValue(), _sliderFS )
	endEvent

	event OnSliderAcceptST( float value )
		RRCombatStaminaValue.SetValue( value )
		SetSliderOptionValueST( RRCombatStaminaValue.GetValue(), _sliderFS )
	endEvent
endState

;
; FUNCTIONS : Combat ------------------------------------------------------------------------------
;

Function updateCombatFlags()
	if (updateModEnabledFlags())
		if (updateModHealFlags())
			if (RRCombatMultHealIndex.GetValueInt() == RRFunctionUserDefined.GetValueInt())
				_combatMultHealFlags = OPTION_FLAG_NONE
			else
				_combatMultHealFlags = OPTION_FLAG_DISABLED
			endIf

			if (isUserdefined(RRCombatHealIndex))
				_combatHealFlags = OPTION_FLAG_NONE
			else
				_combatHealFlags = OPTION_FLAG_DISABLED
			endIf
		else
			_combatMultHealFlags = OPTION_FLAG_DISABLED
			_combatHealFlags = OPTION_FLAG_DISABLED
		endIf

		if (updateModMagickaFlags())
			if (RRCombatMultMagickaIndex.GetValueInt() == RRFunctionUserDefined.GetValueInt())
				_combatMultMagickaFlags = OPTION_FLAG_NONE
			else
				_combatMultMagickaFlags = OPTION_FLAG_DISABLED
			endIf

			if (isUserdefined(RRCombatMagickaIndex))
				_combatMagickaFlags = OPTION_FLAG_NONE
			else
				_combatMagickaFlags = OPTION_FLAG_DISABLED
			endIf
		else
			_combatMultMagickaFlags = OPTION_FLAG_DISABLED
			_combatMagickaFlags = OPTION_FLAG_DISABLED
		endIf

		if (updateModStaminaFlags())
			if (RRCombatMultStaminaIndex.GetValueInt() == RRFunctionUserDefined.GetValueInt())
				_combatMultStaminaFlags = OPTION_FLAG_NONE
			else
				_combatMultStaminaFlags = OPTION_FLAG_DISABLED
			endIf

			if (isUserdefined(RRCombatStaminaIndex))
				_combatStaminaFlags = OPTION_FLAG_NONE
			else
				_combatStaminaFlags = OPTION_FLAG_DISABLED
			endIf
		else
			_combatMultStaminaFlags = OPTION_FLAG_DISABLED
			_combatStaminaFlags = OPTION_FLAG_DISABLED
		endIf
	else
		disableAllFlags()
	endIf
endFunction
