Scriptname RRConfigHelpScript extends RRSkyUIConfigParentScript Hidden 
{Realistic Regeneration for SkyUI : Help Page}

; +-RRSkyUIConfigParentScript
; +-+-RRConfigHelpScript
;   +-+-RRConfigSlidersScript
;     +-+-RRConfigTemplatesScript
;       +-+-RRConfigMiscScript
;         +-+-RRConfigBeastFormScript
;           +-+-RRConfigCombatScript
;             +-+-RRConfigBoostersScript
;               +-+-RRConfigAttributesScript
;                 +-+-RRSkyUIConfigMenuScript

;
; PAGE Help ---------------------------------------------------------------------------------------
;

Function generateHelpPage()
	SetCursorFillMode(TOP_TO_BOTTOM)

	AddHeaderOption("$RRHelpMain")

	AddTextOptionST("HELP_INTRO", "$RRHelpIntro", "$Read")
	AddTextOptionST("HELP_PRIORITY", "$RRHelpPriority", "$Read")
	AddTextOptionST("HELP_VALUE_TYPES", "$RRHelpValuesTypes", "$Read")
	AddTextOptionST("HELP_PAGE_OPTIONS", "$Options", "$Read")
	AddTextOptionST("HELP_PAGE_SAVE_AND_LOAD", "$RRSaveAndLoad", "$Read")

	SetCursorPosition(1)

	AddHeaderOption("$RRPages")

	AddTextOptionST("HELP_PAGE_STAY_AND_SIT", "$RRStayAndSit", "$Read")
	AddTextOptionST("HELP_PAGE_SLEEP_AND_WAIT", "$RRSleepAndWait", "$Read")
	AddTextOptionST("HELP_PAGE_RUN_AND_SPRINT", "$RRRunAndSprint", "$Read")
	AddTextOptionST("HELP_PAGE_POTIONS_AND_FOOD", "$RRPotionsAndFood", "$Read")
	AddTextOptionST("HELP_PAGE_ITEMS_AND_SPELLS", "$RRItemsAndSpells", "$Read")
	AddTextOptionST("HELP_PAGE_COMBAT", "$RRCombat", "$Read")
	AddTextOptionST("HELP_PAGE_BEAST_FORM", "$RRBeastForm", "$Read")
	AddTextOptionST("HELP_PAGE_COURAGE_FATIGUE", "$RRCourageAndFatigue", "$Read")
	AddTextOptionST("HELP_PAGE_ATTRIBUTES", "$RRAttributes", "$Read")
	AddTextOptionST("HELP_PAGE_TEMPLATES", "$RRTemplates", "$Read")
endFunction

;
; STATE Help --------------------------------------------------------------------------------------
;
; STATE Help : Text -------------------------------------------------------------------------------
;

state HELP_INTRO ; Text
	event OnSelectST()
		ShowMessage("$RRMsgHelpIntro", false)
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintHelpIntro")
	endEvent
endState

state HELP_PRIORITY ; Text
	event OnSelectST()
		ShowMessage("$RRMsgHelpPriority", false)
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintHelpPriority")
	endEvent
endState

state HELP_VALUE_TYPES ; Text
	event OnSelectST()
		ShowMessage("$RRMsgHelpValueTypes", false)
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintHelpValueTypes")
	endEvent
endState

state HELP_PAGE_OPTIONS ; Text
	event OnSelectST()
		ShowMessage("$RRMsgHelpOptions", false)
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintHelpOptions")
	endEvent
endState

state HELP_PAGE_SAVE_AND_LOAD ; Text
	event OnSelectST()
		ShowMessage("$RRMsgSaveAndLoad", false)
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintHelpSaveAndLoad")
	endEvent
endState

state HELP_PAGE_TEMPLATES ; Text
	event OnSelectST()
		ShowMessage("$RRMsgHelpTemplates", false)
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintHelpTemplates")
	endEvent
endState

state HELP_PAGE_STAY_AND_SIT ; Text
	event OnSelectST()
		ShowMessage("$RRMsgHelpStayAndSit", false)
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintHelpStayAndSit")
	endEvent
endState

state HELP_PAGE_SLEEP_AND_WAIT ; Text
	event OnSelectST()
		ShowMessage("$RRMsgHelpSleepAndWait", false)
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintHelpSleepAndWait")
	endEvent
endState

state HELP_PAGE_RUN_AND_SPRINT ; Text
	event OnSelectST()
		ShowMessage("$RRMsgHelpRunAndSprint", false)
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintHelpRunAndSprint")
	endEvent
endState

state HELP_PAGE_POTIONS_AND_FOOD ; Text
	event OnSelectST()
		ShowMessage("$RRMsgHelpPotionsAndFood", false)
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintHelpPotionsAndFood")
	endEvent
endState

state HELP_PAGE_ITEMS_AND_SPELLS ; Text
	event OnSelectST()
		ShowMessage("$RRMsgHelpItemsAndSpells", false)
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintHelpItemsAndSpells")
	endEvent
endState

state HELP_PAGE_COMBAT ; Text
	event OnSelectST()
		ShowMessage("$RRMsgHelpCombat", false)
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintHelpCombat")
	endEvent
endState

state HELP_PAGE_BEAST_FORM ; Text
	event OnSelectST()
		ShowMessage("$RRMsgHelpBeastForm", false)
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintHelpBeastForm")
	endEvent
endState

state HELP_PAGE_COURAGE_FATIGUE ; Text
	event OnSelectST()
		ShowMessage("$RRMsgHelpCourageAndFatigue", false)
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintHelpCourageAndFatigue")
	endEvent
endState

state HELP_PAGE_ATTRIBUTES ; Text
	event OnSelectST()
		ShowMessage("$RRMsgHelpAttributes", false)
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintHelpAttributes")
	endEvent
endState
