Scriptname RRConfigMiscScript extends RRConfigTemplatesScript Hidden 
{Realistic Regeneration for SkyUI : Misc. Page}

; +-RRSkyUIConfigParentScript
; +-+-RRConfigHelpScript
;   +-+-RRConfigSlidersScript
;     +-+-RRConfigTemplatesScript
;       +-+-RRConfigMiscScript
;         +-+-RRConfigBeastFormScript
;           +-+-RRConfigCombatScript
;             +-+-RRConfigBoostersScript
;               +-+-RRConfigAttributesScript
;                 +-+-RRSkyUIConfigMenuScript


; PERK --------------------------------------------------------------------------------------------

Perk Property EagleEye30 Auto


;
; PRIVATE VARIABLES -------------------------------------------------------------------------------
;

float fCarryWeight


;
; PAGE MiscOptions --------------------------------------------------------------------------------
;

Function generateMiscOptionsPage()
	SetCursorFillMode(TOP_TO_BOTTOM)


	fCarryWeight = RRControl.getBaseAttrByName( "CarryWeight" )

	AddHeaderOption("$RRCarryWeight", OPTION_FLAG_NONE)
	AddTextOptionST( "CARRY_WEIGHT_CURRENT", "$RRCurrent", Math.Floor( fCarryWeight ), _modEnabledFlags )
	AddSliderOptionST( "CARRY_WEIGHT_MODIFIER", "$RRModifier", RRAttrCarryWeightModifier.GetValueInt(), "{0}", _modEnabledFlags )
	AddTextOptionST( "CARRY_WEIGHT_NEW", "$RRNewValue", Math.Floor( fCarryWeight + RRAttrCarryWeightModifier.GetValueInt() ), _modEnabledFlags )


	AddHeaderOption( "$RRPerks", OPTION_FLAG_NONE )
	Float fEagleEyeStaminaDrain = RRControl.GetPerkValueByPriority( EagleEye30, 15 )
	Int iEagleEyeFlags = _modEnabledFlags

	; in case if some mod has changed this perk in a bad way
	If fEagleEyeStaminaDrain < 0.000000
		iEagleEyeFlags = OPTION_FLAG_DISABLED
	EndIf

	AddToggleOptionST( "EAGLE_EYE_PERK_TOGGLE", "$RREagleEyePerkDrain", RREagleEyeStaminaEnabled.GetValueInt(), iEagleEyeFlags )
	AddSliderOptionST( "EAGLE_EYE_PERK_VALUE", "$RREagleEyePerkValue", fEagleEyeStaminaDrain, _sliderFS, iEagleEyeFlags )

	AddHeaderOption( "$RRSpecialties", OPTION_FLAG_NONE )
	AddToggleOptionST( "PERK_SLOW_TOGGLE", "$RRPerkSlow", RRPerkSlowEnabled.GetValueInt(), _modEnabledFlags )


	AddHeaderOption( "$RRGameSettings", _modEnabledFlags )
	AddSliderOptionST( "SPRINT_STAMINA_DRAIN_MULT", "$RRSprintStaminaDrainMult", RRGSfSprintStaminaDrainMult.GetValue(), _sliderFS, _modEnabledFlags )
	AddSliderOptionST( "SPRINT_STAMINA_WEIGHT_BASE", "$RRSprintStaminaWeightBase", RRGSfSprintStaminaWeightBase.GetValue(), _sliderFS, _modEnabledFlags )
	AddSliderOptionST( "SPRINT_STAMINA_WEIGHT_MULT", "$RRSprintStaminaWeightMult", RRGSfSprintStaminaWeightMult.GetValue(), "{3}", _modEnabledFlags )
	AddSliderOptionST( "STAMINA_ATTACK_WEAPON_MULT", "$RRStaminaAttackWeaponMult", RRGSfStaminaAttackWeaponMult.GetValue(), _sliderFS, _modEnabledFlags )
	AddSliderOptionST( "POWER_ATTACK_STAMINA_PENALTY", "$RRPowerAttackStaminaPenalty", RRGSfPowerAttackStaminaPenalty.GetValue(), _sliderFS, _modEnabledFlags )
	AddSliderOptionST( "STAMINA_BASH_BASE", "$RRStaminaBashBase", RRGSfStaminaBashBase.GetValue(), _sliderFS, _modEnabledFlags )
	AddSliderOptionST( "STAMINA_POWER_BASH_BASE", "$RRStaminaPowerBashBase", RRGSfStaminaPowerBashBase.GetValue(), _sliderFS, _modEnabledFlags )
	AddSliderOptionST( "STAMINA_BLOCK_DMG_MULT", "$RRStaminaBlockDmgMult", RRGSfStaminaBlockDmgMult.GetValue(), _sliderFS, _modEnabledFlags )
	; -- added in 3.10
	AddSliderOptionST( "MAGIC_CASTER_PC_BASE", "$RRMagicCasterPCBase", RRGSfMagicCasterPCSkillCostBase.GetValue(), "{4}", _modEnabledFlags )
	AddSliderOptionST( "MAGIC_CASTER_PC_MULT", "$RRMagicCasterPCMult", RRGSfMagicCasterPCSkillCostMult.GetValue(), _sliderFS, _modEnabledFlags )
	AddSliderOptionST( "MAGIC_CASTER_BASE", "$RRMagicCasterBase", RRGSfMagicCasterSkillCostBase.GetValue(), "{4}", _modEnabledFlags )
	AddSliderOptionST( "MAGIC_CASTER_MULT", "$RRMagicCasterMult", RRGSfMagicCasterSkillCostMult.GetValue(), _sliderFS, _modEnabledFlags )

	SetCursorPosition(1)

	AddHeaderOption( "$RRInterface", _modEnabledFlags )
	AddToggleOptionST( "HIDE_IN_UI", "$RRHideInUI", RRHideInUI.GetValueInt(), _modEnabledFlags )
	AddSliderOptionST( "MAX_SLIDER_VALUE", "$RRMaxSliderValue", RRsliderMaxValue.GetValue(), _sliderFS, _modEnabledFlags )

	AddHeaderOption("$RRRestoreDefaults", OPTION_FLAG_NONE)
	AddTextOptionST("RESTORE_DEFAULT_REGENERATION", "$RRRestoreDefaultRegen", "$Apply", OPTION_FLAG_NONE)
	AddTextOptionST("RESTORE_DEFAULT_COMBAT_MULTS", "$RRRestoreDefaultCombatMults", "$Apply", OPTION_FLAG_NONE)

	AddHeaderOption("$RRTuningOptions", _modEnabledFlags)
	AddSliderOptionST("SPELLS_AT_VALUE", "$RRUpdateSpellsTime", RRUpdateSpellsAt.GetValue(), _sliderFS, _modEnabledFlags)
	AddSliderOptionST("SLEEP_AT_VALUE", "$RRUpdateSleepTime", RRUpdateSleepAt.GetValue(), _sliderFS, _modEnabledFlags)
	AddSliderOptionST("WAIT_AT_VALUE", "$RRUpdateWaitTime", RRUpdateWaitAt.GetValue(), _sliderFS, _modEnabledFlags)
	AddSliderOptionST("MIN_WAIT_VALUE", "$RRMinWaitInterval", RRMinWaitPeriod.GetValue(), _sliderFS, _modEnabledFlags)
	AddSliderOptionST("WEREWOLF_INTERVAL", "$RRWerewolfUpdateInterval", RRWerewolfUpdateInterval.GetValue(), _sliderFS, _modEnabledFlags)
	AddSliderOptionST("BOOSTERS_AT_VALUE", "$RRUpdateBoostersTime", RRUpdateBoostersAt.GetValue(), _sliderFS, _modEnabledFlags)
	AddSliderOptionST("FATIGUES_NOCK_AT_VALUE", "$RRUpdateFatigueNockTime", RRUpdateFatigueBowstringAt.GetValue(), _sliderFS, _modEnabledFlags)
	AddSliderOptionST( "ATTRIBUTES_AT_VALUE", "$RRUpdateAttributesTime", RRUpdateAttributesAt.GetValue(), _sliderFS, _modEnabledFlags )
endFunction

;
; FUNCTIONS : MiscOptions -------------------------------------------------------------------------
;

Function updateMiscOptionsFlags()
	updateModEnabledFlags()
endFunction

;
; STATE MiscOptions -------------------------------------------------------------------------------
;

State HIDE_IN_UI ; TOGGLE
	event OnSelectST()
		RRSkyUILib.toggle( RRHideInUI )
		SetToggleOptionValueST( RRHideInUI.GetValueInt() )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintHideInUI" )
	endEvent
EndState

State MAX_SLIDER_VALUE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderMaxValue.GetValue() )
		SetSliderDialogDefaultValue( 5.0 )
		SetSliderDialogRange( 5.0, 100.0 )
		SetSliderDialogInterval( 1.0 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderMaxValue.SetValue( value )
		SetSliderOptionValueST( RRsliderMaxValue.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRsliderMaxValue.SetValue( 5.0 )
		SetSliderOptionValueST( RRsliderMaxValue.GetValue(), _sliderFS )
		ForcePageReset()
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintMaxSliderValue" )
	endEvent
EndState

state RESTORE_DEFAULT_REGENERATION ; TEXT
	event OnSelectST()
		RRControl.restoreDefaultRegeneration()
		ShowMessage( "$RRMsgReady", false )
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintRestoreDefaultRegen")
	endEvent
endState

state RESTORE_DEFAULT_COMBAT_MULTS ; TEXT
	event OnSelectST()
		RRControl.restoreDefaultCombatMults()
		ShowMessage( "$RRMsgReady", false )
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintRestoreDefaultCombatMults")
	endEvent
endState

state SPELLS_AT_VALUE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRUpdateSpellsAt.GetValue() )
		SetSliderDialogDefaultValue( 0.5 )
		SetSliderDialogRange( 0.1, 2.0 )
		SetSliderDialogInterval( 0.1 )
	endEvent

	event OnSliderAcceptST( float value )
		RRUpdateSpellsAt.SetValue( value )
		SetSliderOptionValueST( RRUpdateSpellsAt.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRUpdateSpellsAt.SetValue( 0.5 )
		SetSliderOptionValueST( RRUpdateSpellsAt.GetValue(), _sliderFS )
		ForcePageReset()
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintUpdateSpellsTime" )
	endEvent
endState

state SLEEP_AT_VALUE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRUpdateSleepAt.GetValue() )
		SetSliderDialogDefaultValue( 2.0 )
		SetSliderDialogRange( 0.1, 10.0 )
		SetSliderDialogInterval( 0.1 )
	endEvent

	event OnSliderAcceptST( float value )
		RRUpdateSleepAt.SetValue( value )
		SetSliderOptionValueST( RRUpdateSleepAt.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRUpdateSleepAt.SetValue( 2.0 )
		SetSliderOptionValueST( RRUpdateSleepAt.GetValue(), _sliderFS )
		ForcePageReset()
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintUpdateSleepTime" )
	endEvent
endState

state WAIT_AT_VALUE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRUpdateWaitAt.GetValue() )
		SetSliderDialogDefaultValue( 2.0 )
		SetSliderDialogRange( 0.1, 10.0 )
		SetSliderDialogInterval( 0.1 )
	endEvent

	event OnSliderAcceptST( float value )
		RRUpdateWaitAt.SetValue( value )
		SetSliderOptionValueST( RRUpdateWaitAt.GetValue(), _sliderFS )
	endEvent
	
	event OnDefaultST()
		RRUpdateWaitAt.SetValue( 2.0 )
		SetSliderOptionValueST( RRUpdateWaitAt.GetValue(), _sliderFS )
		ForcePageReset()
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintUpdateWaitTime" )
	endEvent
endState

state MIN_WAIT_VALUE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRMinWaitPeriod.GetValue() )
		SetSliderDialogDefaultValue( 10.0 )
		SetSliderDialogRange( 1.0, 360.0 )
		SetSliderDialogInterval( 1.0 )
	endEvent

	event OnSliderAcceptST( float value )
		RRMinWaitPeriod.SetValue( value )
		SetSliderOptionValueST( RRMinWaitPeriod.GetValue(), _sliderFS )
	endEvent
	
	event OnDefaultST()
		RRMinWaitPeriod.SetValue( 10.0 )
		SetSliderOptionValueST( RRMinWaitPeriod.GetValue(), _sliderFS )
		ForcePageReset()
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintMinWaitInterval" )
	endEvent
endState

state WEREWOLF_INTERVAL ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRWerewolfUpdateInterval.GetValue() )
		SetSliderDialogDefaultValue( 1.0 )
		SetSliderDialogRange( 0.5, 5.0 )
		SetSliderDialogInterval( 0.5 )
	endEvent

	event OnSliderAcceptST( float value )
		RRWerewolfUpdateInterval.SetValue( value )
		SetSliderOptionValueST( RRWerewolfUpdateInterval.GetValue(), _sliderFS )
	endEvent
	
	event OnDefaultST()
		RRWerewolfUpdateInterval.SetValue( 1.0 )
		SetSliderOptionValueST( RRWerewolfUpdateInterval.GetValue(), _sliderFS )
		ForcePageReset()
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintWerewolfUpdateInterval" )
	endEvent
endState

state BOOSTERS_AT_VALUE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRUpdateBoostersAt.GetValue() )
		SetSliderDialogDefaultValue( 0.5 )
		SetSliderDialogRange( 0.1, 10.0 )
		SetSliderDialogInterval( 0.1 )
	endEvent

	event OnSliderAcceptST( float value )
		RRUpdateBoostersAt.SetValue( value )
		SetSliderOptionValueST( RRUpdateBoostersAt.GetValue(), _sliderFS )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintUpdateBoostersTime" )
	endEvent
endState

state FATIGUES_NOCK_AT_VALUE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRUpdateFatigueBowstringAt.GetValue() )
		SetSliderDialogDefaultValue( 0.5 )
		SetSliderDialogRange( 0.1, 10.0 )
		SetSliderDialogInterval( 0.1 )
	endEvent

	event OnSliderAcceptST( float value )
		RRUpdateFatigueBowstringAt.SetValue( value )
		SetSliderOptionValueST( RRUpdateFatigueBowstringAt.GetValue(), _sliderFS )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintUpdateFatigueNockTime" )
	endEvent
endState

state ATTRIBUTES_AT_VALUE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRUpdateAttributesAt.GetValue() )
		SetSliderDialogDefaultValue( 0.5 )
		SetSliderDialogRange( 0.1, 10.0 )
		SetSliderDialogInterval( 0.1 )
	endEvent

	event OnDefaultST()
		RRUpdateAttributesAt.SetValue( 0.5 )
		SetSliderOptionValueST( RRUpdateAttributesAt.GetValue(), _sliderFS )
	endEvent

	event OnSliderAcceptST( float value )
		RRUpdateAttributesAt.SetValue( value )
		SetSliderOptionValueST( RRUpdateAttributesAt.GetValue(), _sliderFS )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintUpdateAttributesTime" )
	endEvent
endState



State CARRY_WEIGHT_CURRENT ; TEXT
	event OnHighlightST()
		SetInfoText( "$RRhintCarryWeight" )
	endEvent
EndState

State CARRY_WEIGHT_MODIFIER ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRAttrCarryWeightModifier.GetValue() )
		SetSliderDialogDefaultValue( 0.0 )
		SetSliderDialogRange( -1000.0, 1000.0 )
		SetSliderDialogInterval( 5.0 )
	endEvent

	event OnSliderAcceptST( float value )
		RRAttrCarryWeightModifier.SetValue( value )
		SetSliderOptionValueST( RRAttrCarryWeightModifier.GetValue(), "{0}" )
		SetTextOptionValueST( Math.Floor( fCarryWeight + RRAttrCarryWeightModifier.GetValue() ), false, "CARRY_WEIGHT_NEW" )
	endEvent

	event OnDefaultST()
		RRAttrCarryWeightModifier.SetValue( 0.0 )
		SetSliderOptionValueST( RRAttrCarryWeightModifier.GetValue(), "{0}" )
		SetTextOptionValueST( Math.Floor( fCarryWeight + RRAttrCarryWeightModifier.GetValue() ), false, "CARRY_WEIGHT_NEW" )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintCarryWeightInfo" )
	endEvent
EndState

State CARRY_WEIGHT_NEW ; TEXT
	event OnHighlightST()
		SetInfoText( "$RRhintAttrNew" )
	endEvent
EndState


state SPRINT_STAMINA_DRAIN_MULT ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRGSfSprintStaminaDrainMult.GetValue() )
		SetSliderDialogDefaultValue( 7.0 )
		SetSliderDialogRange( 0.0, 10.0 )
		SetSliderDialogInterval( 0.01 )
	endEvent

	event OnSliderAcceptST( float value )
		RRGSfSprintStaminaDrainMult.SetValue( value )
		SetSliderOptionValueST( RRGSfSprintStaminaDrainMult.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRGSfSprintStaminaDrainMult.SetValue( 7.0 )
		SetSliderOptionValueST( RRGSfSprintStaminaDrainMult.GetValue(), _sliderFS )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintSprintStaminaDrain" )
	endEvent
endState

state SPRINT_STAMINA_WEIGHT_BASE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRGSfSprintStaminaWeightBase.GetValue() )
		SetSliderDialogDefaultValue( 1.0 )
		SetSliderDialogRange( 0.0, 2.0 )
		SetSliderDialogInterval( 0.01 )
	endEvent

	event OnSliderAcceptST( float value )
		RRGSfSprintStaminaWeightBase.SetValue( value )
		SetSliderOptionValueST( RRGSfSprintStaminaWeightBase.GetValue(), _sliderFS )
	endEvent
	
	event OnDefaultST()
		RRGSfSprintStaminaWeightBase.SetValue( 1.0 )
		SetSliderOptionValueST( RRGSfSprintStaminaWeightBase.GetValue(), _sliderFS )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintSprintStaminaDrain" )
	endEvent
endState


state SPRINT_STAMINA_WEIGHT_MULT ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRGSfSprintStaminaWeightMult.GetValue() )
		SetSliderDialogDefaultValue( 0.02 )
		SetSliderDialogRange( 0.0, 0.1 )
		SetSliderDialogInterval( 0.001 )
	endEvent

	event OnSliderAcceptST( float value )
		RRGSfSprintStaminaWeightMult.SetValue( value )
		SetSliderOptionValueST( RRGSfSprintStaminaWeightMult.GetValue(), "{3}" )
	endEvent

	event OnDefaultST()
		RRGSfSprintStaminaWeightMult.SetValue( 0.02 )
		SetSliderOptionValueST( RRGSfSprintStaminaWeightMult.GetValue(), "{3}" )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintSprintStaminaDrain" )
	endEvent
endState


state STAMINA_ATTACK_WEAPON_MULT ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRGSfStaminaAttackWeaponMult.GetValue() )
		SetSliderDialogDefaultValue( 1.0 )
		SetSliderDialogRange( 0.0, 2.0 )
		SetSliderDialogInterval( 0.01 )
	endEvent

	event OnSliderAcceptST( float value )
		RRGSfStaminaAttackWeaponMult.SetValue( value )
		SetSliderOptionValueST( RRGSfStaminaAttackWeaponMult.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRGSfStaminaAttackWeaponMult.SetValue( 1.0 )
		SetSliderOptionValueST( RRGSfStaminaAttackWeaponMult.GetValue(), _sliderFS )
	endEvent
	
	event OnHighlightST()
		SetInfoText( "$RRhintStaminaAttack" )
	endEvent
endState


state POWER_ATTACK_STAMINA_PENALTY ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRGSfPowerAttackStaminaPenalty.GetValue() )
		SetSliderDialogDefaultValue( 2.0 )
		SetSliderDialogRange( 0.0, 5.0 )
		SetSliderDialogInterval( 0.01 )
	endEvent

	event OnSliderAcceptST( float value )
		RRGSfPowerAttackStaminaPenalty.SetValue( value )
		SetSliderOptionValueST( RRGSfPowerAttackStaminaPenalty.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRGSfPowerAttackStaminaPenalty.SetValue( 2.0 )
		SetSliderOptionValueST( RRGSfPowerAttackStaminaPenalty.GetValue(), _sliderFS )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintStaminaAttack" )
	endEvent
endState

state STAMINA_BASH_BASE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRGSfStaminaBashBase.GetValue() )
		SetSliderDialogDefaultValue( 35.0 )
		SetSliderDialogRange( 0.0, 50.0 )
		SetSliderDialogInterval( 0.50 )
	endEvent

	event OnSliderAcceptST( float value )
		RRGSfStaminaBashBase.SetValue( value )
		SetSliderOptionValueST( RRGSfStaminaBashBase.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRGSfStaminaBashBase.SetValue( 35.0 )
		SetSliderOptionValueST( RRGSfStaminaBashBase.GetValue(), _sliderFS )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintStaminaBash" )
	endEvent
endState

state STAMINA_POWER_BASH_BASE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRGSfStaminaPowerBashBase.GetValue() )
		SetSliderDialogDefaultValue( 55.0 )
		SetSliderDialogRange( 0.0, 100.0 )
		SetSliderDialogInterval( 0.5 )
	endEvent

	event OnSliderAcceptST( float value )
		RRGSfStaminaPowerBashBase.SetValue( value )
		SetSliderOptionValueST( RRGSfStaminaPowerBashBase.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRGSfStaminaPowerBashBase.SetValue( 55.0 )
		SetSliderOptionValueST( RRGSfStaminaPowerBashBase.GetValue(), _sliderFS )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintStaminaPowerBash" )
	endEvent
endState


state STAMINA_BLOCK_DMG_MULT ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRGSfStaminaBlockDmgMult.GetValue() )
		SetSliderDialogDefaultValue( 0.25 )
		SetSliderDialogRange( 0.0, 1.0 )
		SetSliderDialogInterval( 0.01 )
	endEvent

	event OnSliderAcceptST( float value )
		RRGSfStaminaBlockDmgMult.SetValue( value )
		SetSliderOptionValueST( RRGSfStaminaBlockDmgMult.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRGSfStaminaBlockDmgMult.SetValue( 0.25 )
		SetSliderOptionValueST( RRGSfStaminaBlockDmgMult.GetValue(), _sliderFS )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintStaminaBlock" )
	endEvent
endState


state MAGIC_CASTER_PC_BASE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRGSfMagicCasterPCSkillCostBase.GetValue() )
		SetSliderDialogDefaultValue( 0.0025 )
		SetSliderDialogRange( 0.0, 0.0100 )
		SetSliderDialogInterval( 0.0001 )
	endEvent

	event OnSliderAcceptST( float value )
		RRGSfMagicCasterPCSkillCostBase.SetValue( value )
		SetSliderOptionValueST( RRGSfMagicCasterPCSkillCostBase.GetValue(), "{4}" )
	endEvent

	event OnDefaultST()
		RRGSfMagicCasterPCSkillCostBase.SetValue( 0.0025 )
		SetSliderOptionValueST( RRGSfMagicCasterPCSkillCostBase.GetValue(), "{4}" )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintMagicCasterPC" )
	endEvent
endState

state MAGIC_CASTER_PC_MULT ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRGSfMagicCasterPCSkillCostMult.GetValue() )
		SetSliderDialogDefaultValue( 1.0 )
		SetSliderDialogRange( 0.0, 2.0 )
		SetSliderDialogInterval( 0.01 )
	endEvent

	event OnSliderAcceptST( float value )
		RRGSfMagicCasterPCSkillCostMult.SetValue( value )
		SetSliderOptionValueST( RRGSfMagicCasterPCSkillCostMult.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRGSfMagicCasterPCSkillCostMult.SetValue( 0.0025 )
		SetSliderOptionValueST( RRGSfMagicCasterPCSkillCostMult.GetValue(), _sliderFS )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintMagicCasterPC" )
	endEvent
endState

state MAGIC_CASTER_BASE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRGSfMagicCasterSkillCostBase.GetValue() )
		SetSliderDialogDefaultValue( 0.0050 )
		SetSliderDialogRange( 0.0, 0.0100 )
		SetSliderDialogInterval( 0.0001 )
	endEvent

	event OnSliderAcceptST( float value )
		RRGSfMagicCasterSkillCostBase.SetValue( value )
		SetSliderOptionValueST( RRGSfMagicCasterSkillCostBase.GetValue(), "{4}" )
	endEvent

	event OnDefaultST()
		RRGSfMagicCasterSkillCostBase.SetValue( 0.0050 )
		SetSliderOptionValueST( RRGSfMagicCasterSkillCostBase.GetValue(), "{4}" )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintMagicCaster" )
	endEvent
endState

state MAGIC_CASTER_MULT ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRGSfMagicCasterSkillCostMult.GetValue() )
		SetSliderDialogDefaultValue( 0.5 )
		SetSliderDialogRange( 0.0, 2.0 )
		SetSliderDialogInterval( 0.01 )
	endEvent

	event OnSliderAcceptST( float value )
		RRGSfMagicCasterSkillCostMult.SetValue( value )
		SetSliderOptionValueST( RRGSfMagicCasterSkillCostMult.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRGSfMagicCasterSkillCostMult.SetValue( 0.50 )
		SetSliderOptionValueST( RRGSfMagicCasterSkillCostMult.GetValue(), _sliderFS )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintMagicCaster" )
	endEvent
endState


State EAGLE_EYE_PERK_TOGGLE ; TOGGLE
	event OnSelectST()
		RRSkyUILib.toggle( RREagleEyeStaminaEnabled )
		SetToggleOptionValueST( RREagleEyeStaminaEnabled.GetValueInt() )
	endEvent

	event OnDefaultST()
		RREagleEyeStaminaEnabled.SetValueInt(0)
		SetToggleOptionValueST( RREagleEyeStaminaEnabled.GetValueInt() )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintEagleEyePerk" )
	endEvent
EndState

state EAGLE_EYE_PERK_VALUE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRControl.GetPerkValueByPriority( EagleEye30, 15 ) )
		SetSliderDialogDefaultValue( 10.0 )
		SetSliderDialogRange( 0.0, 20.0 )
		SetSliderDialogInterval( 0.1 )
	endEvent

	event OnSliderAcceptST( float value )
		if ( RREagleEyeStaminaEnabled.GetValueInt() == 1 )
			; on load game, otherwise this value will be "forgotten"
			; see RRControl.reset() for details
			RREagleEyeStaminaValue.SetValue( value )

			; apply new value instantly
			RRControl.SetPerkValueByPriority( EagleEye30, 15, value )
		endIf

		SetSliderOptionValueST( RRControl.GetPerkValueByPriority( EagleEye30, 15 ), _sliderFS )
	endEvent

	event OnDefaultST()
		if ( RREagleEyeStaminaEnabled.GetValueInt() == 1 )
			RREagleEyeStaminaValue.SetValue( 10.0 )
			RRControl.SetPerkValueByPriority( EagleEye30, 15, 10.0 )
			SetSliderOptionValueST( RRControl.GetPerkValueByPriority( EagleEye30, 15 ), _sliderFS )
		endIf
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintEagleEyePerk" )
	endEvent
endState

State PERK_SLOW_TOGGLE ; TOGGLE
	event OnSelectST()
		RRSkyUILib.toggle( RRPerkSlowEnabled )
		SetToggleOptionValueST( RRPerkSlowEnabled.GetValueInt() )
	endEvent

	event OnHighlightST()
		SetInfoText( "$RRhintPerkSlow" )
	endEvent
EndState
