Scriptname RRConfigSlidersScript extends RRConfigHelpScript Hidden 
{Realistic Regeneration for SkyUI : Sliders Page}

; +-RRSkyUIConfigParentScript
; +-+-RRConfigHelpScript
;   +-+-RRConfigSlidersScript
;     +-+-RRConfigTemplatesScript
;       +-+-RRConfigMiscScript
;         +-+-RRConfigBeastFormScript
;           +-+-RRConfigCombatScript
;             +-+-RRConfigBoostersScript
;               +-+-RRConfigAttributesScript
;                 +-+-RRSkyUIConfigMenuScript

;
; FUNCTIONS ---------------------------------------------------------------------------------------
;

Function updateSlidersOptionsFlags()
	if ( updateModEnabledFlags() )
		updateModHealFlags()
		updateModMagickaFlags()
		updateModStaminaFlags()
	else
		disableAllFlags()
	endIf
endFunction

;
; PAGE SlidersOptions -----------------------------------------------------------------------------
;

Function generateSlidersOptionsPage()
	SetCursorFillMode(TOP_TO_BOTTOM)

	AddHeaderOption( "$Health", _modEnabledFlags )
	AddSliderOptionST( "SLIDER_HEAL_MINIMUM", "$RRMinimum", RRsliderHealMin.GetValue(), _sliderFS, _modHealFlags )
	AddSliderOptionST( "SLIDER_HEAL_MAXIMUM", "$RRMaximum", RRsliderHealMax.GetValue(), _sliderFS, _modHealFlags )
	AddSliderOptionST( "SLIDER_HEAL_INTERVAL", "$RRInterval", RRsliderHealInterval.GetValue(), _sliderFS, _modHealFlags )

	AddHeaderOption( "$Magicka", _modEnabledFlags )
	AddSliderOptionST( "SLIDER_MAGICKA_MINIMUM", "$RRMinimum", RRsliderMagickaMin.GetValue(), _sliderFS, _modMagickaFlags )
	AddSliderOptionST( "SLIDER_MAGICKA_MAXIMUM", "$RRMaximum", RRsliderMagickaMax.GetValue(), _sliderFS, _modMagickaFlags )
	AddSliderOptionST( "SLIDER_MAGICKA_INTERVAL", "$RRInterval", RRsliderMagickaInterval.GetValue(), _sliderFS, _modMagickaFlags )

	AddHeaderOption( "$Stamina", _modEnabledFlags )
	AddSliderOptionST( "SLIDER_STAMINA_MINIMUM", "$RRMinimum", RRsliderStaminaMin.GetValue(), _sliderFS, _modStaminaFlags )
	AddSliderOptionST( "SLIDER_STAMINA_MAXIMUM", "$RRMaximum", RRsliderStaminaMax.GetValue(), _sliderFS, _modStaminaFlags )
	AddSliderOptionST( "SLIDER_STAMINA_INTERVAL", "$RRInterval", RRsliderStaminaInterval.GetValue(), _sliderFS, _modStaminaFlags )

	SetCursorPosition(1) ; combat multipliers

	AddHeaderOption( "$RRSlidersCombatHealth", _modEnabledFlags )
	AddSliderOptionST( "SLIDER_COMBAT_HEAL_MINIMUM", "$RRMinimum", RRsliderCMHealMin.GetValue(), _sliderFS, _modHealFlags )
	AddSliderOptionST( "SLIDER_COMBAT_HEAL_MAXIMUM", "$RRMaximum", RRsliderCMHealMax.GetValue(), _sliderFS, _modHealFlags )
	AddSliderOptionST( "SLIDER_COMBAT_HEAL_INTERVAL", "$RRInterval", RRsliderCMHealInterval.GetValue(), _sliderFS, _modHealFlags )

	AddHeaderOption( "$RRSlidersCombatMagicka", _modEnabledFlags )
	AddSliderOptionST( "SLIDER_COMBAT_MAGICKA_MINIMUM", "$RRMinimum", RRsliderCMMagickaMin.GetValue(), _sliderFS, _modMagickaFlags )
	AddSliderOptionST( "SLIDER_COMBAT_MAGICKA_MAXIMUM", "$RRMaximum", RRsliderCMMagickaMax.GetValue(), _sliderFS, _modMagickaFlags )
	AddSliderOptionST( "SLIDER_COMBAT_MAGICKA_INTERVAL", "$RRInterval", RRsliderCMMagickaInterval.GetValue(), _sliderFS, _modMagickaFlags )

	AddHeaderOption( "$RRSlidersCombatStamina", _modEnabledFlags )
	AddSliderOptionST( "SLIDER_COMBAT_STAMINA_MINIMUM", "$RRMinimum", RRsliderCMStaminaMin.GetValue(), _sliderFS, _modStaminaFlags )
	AddSliderOptionST( "SLIDER_COMBAT_STAMINA_MAXIMUM", "$RRMaximum", RRsliderCMStaminaMax.GetValue(), _sliderFS, _modStaminaFlags )
	AddSliderOptionST( "SLIDER_COMBAT_STAMINA_INTERVAL", "$RRInterval", RRsliderCMStaminaInterval.GetValue(), _sliderFS, _modStaminaFlags )
endFunction


;
; STATE SlidersOptions ----------------------------------------------------------------------------
;

State SLIDER_HEAL_MINIMUM ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderHealMin.GetValue() )
		SetSliderDialogDefaultValue( 0.0 )
		SetSliderDialogRange( 0.0, 0.7 )
		SetSliderDialogInterval( 0.01 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderHealMin.SetValue( value )
		SetSliderOptionValueST( RRsliderHealMin.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRsliderHealMin.SetValue( 0.0 )
		SetSliderOptionValueST( RRsliderHealMin.GetValue(), _sliderFS )
	endEvent
EndState

State SLIDER_HEAL_MAXIMUM ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderHealMax.GetValue() )
		SetSliderDialogDefaultValue( 0.7 )
		SetSliderDialogRange( 0.7, RRsliderMaxValue.GetValue() )
		SetSliderDialogInterval( 0.1 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderHealMax.SetValue( value )
		SetSliderOptionValueST( RRsliderHealMax.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRsliderHealMax.SetValue( 0.7 )
		SetSliderOptionValueST( RRsliderHealMax.GetValue(), _sliderFS )
	endEvent
EndState

State SLIDER_HEAL_INTERVAL ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderHealInterval.GetValue() )
		SetSliderDialogDefaultValue( 0.01 )
		SetSliderDialogRange( 0.01, 1.0 )
		SetSliderDialogInterval( 0.01 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderHealInterval.SetValue( value )
		SetSliderOptionValueST( RRsliderHealInterval.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRsliderHealInterval.SetValue( 0.01 )
		SetSliderOptionValueST( RRsliderHealInterval.GetValue(), _sliderFS )
	endEvent
EndState

State SLIDER_MAGICKA_MINIMUM ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderMagickaMin.GetValue() )
		SetSliderDialogDefaultValue( 0.0 )
		SetSliderDialogRange( 0.0, 1.0 )
		SetSliderDialogInterval( 0.01 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderMagickaMin.SetValue( value )
		SetSliderOptionValueST( RRsliderMagickaMin.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRsliderMagickaMin.SetValue( 0.0 )
		SetSliderOptionValueST( RRsliderMagickaMin.GetValue(), _sliderFS )
	endEvent
EndState

State SLIDER_MAGICKA_MAXIMUM ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderMagickaMax.GetValue() )
		SetSliderDialogDefaultValue( 3.0 )
		SetSliderDialogRange( 3.0, RRsliderMaxValue.GetValue() )
		SetSliderDialogInterval( 1.0 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderMagickaMax.SetValue( value )
		SetSliderOptionValueST( RRsliderMagickaMax.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRsliderMagickaMax.SetValue( 3.0 )
		SetSliderOptionValueST( RRsliderMagickaMax.GetValue(), _sliderFS )
	endEvent
EndState

State SLIDER_MAGICKA_INTERVAL ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderMagickaInterval.GetValue() )
		SetSliderDialogDefaultValue( 0.01 )
		SetSliderDialogRange( 0.01, 1.0 )
		SetSliderDialogInterval( 0.01 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderMagickaInterval.SetValue( value )
		SetSliderOptionValueST( RRsliderMagickaInterval.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRsliderMagickaInterval.SetValue( 0.01 )
		SetSliderOptionValueST( RRsliderMagickaInterval.GetValue(), _sliderFS )
	endEvent
EndState

State SLIDER_STAMINA_MINIMUM ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderStaminaMin.GetValue() )
		SetSliderDialogDefaultValue( 0.0 )
		SetSliderDialogRange( 0.0, 1.0 )
		SetSliderDialogInterval( 0.01 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderStaminaMin.SetValue( value )
		SetSliderOptionValueST( RRsliderStaminaMin.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRsliderStaminaMin.SetValue( 0.0 )
		SetSliderOptionValueST( RRsliderStaminaMin.GetValue(), _sliderFS )
	endEvent
EndState

State SLIDER_STAMINA_MAXIMUM ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderStaminaMax.GetValue() )
		SetSliderDialogDefaultValue( 5.0 )
		SetSliderDialogRange( 5.0, RRsliderMaxValue.GetValue() )
		SetSliderDialogInterval( 1.0 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderStaminaMax.SetValue( value )
		SetSliderOptionValueST( RRsliderStaminaMax.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRsliderStaminaMax.SetValue( 5.0 )
		SetSliderOptionValueST( RRsliderStaminaMax.GetValue(), _sliderFS )
	endEvent
EndState

State SLIDER_STAMINA_INTERVAL ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderStaminaInterval.GetValue() )
		SetSliderDialogDefaultValue( 0.01 )
		SetSliderDialogRange( 0.01, 1.0 )
		SetSliderDialogInterval( 0.01 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderStaminaInterval.SetValue( value )
		SetSliderOptionValueST( RRsliderStaminaInterval.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRsliderStaminaInterval.SetValue( 0.01 )
		SetSliderOptionValueST( RRsliderStaminaInterval.GetValue(), _sliderFS )
	endEvent
EndState

;
; STATE SlidersOptions : Sliders : Combat ---------------------------------------------------------
;

State SLIDER_COMBAT_HEAL_MINIMUM ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderCMHealMin.GetValue() )
		SetSliderDialogDefaultValue( 0.0 )
		SetSliderDialogRange( 0.0, 1.0 )
		SetSliderDialogInterval( 0.01 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderCMHealMin.SetValue( value )
		SetSliderOptionValueST( RRsliderCMHealMin.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRsliderCMHealMin.SetValue( 0.0 )
		SetSliderOptionValueST( RRsliderCMHealMin.GetValue(), _sliderFS )
	endEvent
EndState

State SLIDER_COMBAT_HEAL_MAXIMUM ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderCMHealMax.GetValue() )
		SetSliderDialogDefaultValue( 1.0 )
		SetSliderDialogRange( 1.0, RRsliderMaxValue.GetValue() )
		SetSliderDialogInterval( 1.0 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderCMHealMax.SetValue( value )
		SetSliderOptionValueST( RRsliderCMHealMax.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRsliderCMHealMax.SetValue( 1.0 )
		SetSliderOptionValueST( RRsliderCMHealMax.GetValue(), _sliderFS )
	endEvent
EndState

State SLIDER_COMBAT_HEAL_INTERVAL ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderCMHealInterval.GetValue() )
		SetSliderDialogDefaultValue( 0.01 )
		SetSliderDialogRange( 0.01, 1.0 )
		SetSliderDialogInterval( 0.01 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderCMHealInterval.SetValue( value )
		SetSliderOptionValueST( RRsliderCMHealInterval.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRsliderCMHealInterval.SetValue( 0.01 )
		SetSliderOptionValueST( RRsliderCMHealInterval.GetValue(), _sliderFS )
	endEvent
EndState

State SLIDER_COMBAT_MAGICKA_MINIMUM ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderCMMagickaMin.GetValue() )
		SetSliderDialogDefaultValue( 0.0 )
		SetSliderDialogRange( 0.0, 1.0 )
		SetSliderDialogInterval( 0.01 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderCMMagickaMin.SetValue( value )
		SetSliderOptionValueST( RRsliderCMMagickaMin.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRsliderCMMagickaMin.SetValue( 0.0 )
		SetSliderOptionValueST( RRsliderCMMagickaMin.GetValue(), _sliderFS )
	endEvent
EndState

State SLIDER_COMBAT_MAGICKA_MAXIMUM ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderCMMagickaMax.GetValue() )
		SetSliderDialogDefaultValue( 1.0 )
		SetSliderDialogRange( 1.0, RRsliderMaxValue.GetValue() )
		SetSliderDialogInterval( 1.0 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderCMMagickaMax.SetValue( value )
		SetSliderOptionValueST( RRsliderCMMagickaMax.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRsliderCMMagickaMax.SetValue( 1.0 )
		SetSliderOptionValueST( RRsliderCMMagickaMax.GetValue(), _sliderFS )
	endEvent
EndState

State SLIDER_COMBAT_MAGICKA_INTERVAL ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderCMMagickaInterval.GetValue() )
		SetSliderDialogDefaultValue( 0.01 )
		SetSliderDialogRange( 0.01, 1.0 )
		SetSliderDialogInterval( 0.01 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderCMMagickaInterval.SetValue( value )
		SetSliderOptionValueST( RRsliderCMMagickaInterval.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRsliderCMMagickaInterval.SetValue( 0.01 )
		SetSliderOptionValueST( RRsliderCMMagickaInterval.GetValue(), _sliderFS )
	endEvent
EndState

State SLIDER_COMBAT_STAMINA_MINIMUM ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderCMStaminaMin.GetValue() )
		SetSliderDialogDefaultValue( 0.0 )
		SetSliderDialogRange( 0.0, 1.0 )
		SetSliderDialogInterval( 0.01 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderCMStaminaMin.SetValue( value )
		SetSliderOptionValueST( RRsliderCMStaminaMin.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRsliderCMStaminaMin.SetValue( 0.0 )
		SetSliderOptionValueST( RRsliderCMStaminaMin.GetValue(), _sliderFS )
	endEvent
EndState

State SLIDER_COMBAT_STAMINA_MAXIMUM ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderCMStaminaMax.GetValue() )
		SetSliderDialogDefaultValue( 1.0 )
		SetSliderDialogRange( 1.0, RRsliderMaxValue.GetValue() )
		SetSliderDialogInterval( 1.0 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderCMStaminaMax.SetValue( value )
		SetSliderOptionValueST( RRsliderCMStaminaMax.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRsliderCMStaminaMax.SetValue( 1.0 )
		SetSliderOptionValueST( RRsliderCMStaminaMax.GetValue(), _sliderFS )
	endEvent
EndState

State SLIDER_COMBAT_STAMINA_INTERVAL ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue( RRsliderCMStaminaInterval.GetValue() )
		SetSliderDialogDefaultValue( 0.01 )
		SetSliderDialogRange( 0.01, 1.0 )
		SetSliderDialogInterval( 0.01 )
	endEvent

	event OnSliderAcceptST( float value )
		RRsliderCMStaminaInterval.SetValue( value )
		SetSliderOptionValueST( RRsliderCMStaminaInterval.GetValue(), _sliderFS )
	endEvent

	event OnDefaultST()
		RRsliderCMStaminaInterval.SetValue( 0.01 )
		SetSliderOptionValueST( RRsliderCMStaminaInterval.GetValue(), _sliderFS )
	endEvent
EndState
