Scriptname RRConfigTemplatesScript extends RRConfigSlidersScript Hidden 
{Realistic Regeneration for SkyUI : Templates Page}

; +-RRSkyUIConfigParentScript
; +-+-RRConfigHelpScript
;   +-+-RRConfigSlidersScript
;     +-+-RRConfigTemplatesScript
;       +-+-RRConfigMiscScript
;         +-+-RRConfigBeastFormScript
;           +-+-RRConfigCombatScript
;             +-+-RRConfigBoostersScript
;               +-+-RRConfigAttributesScript
;                 +-+-RRSkyUIConfigMenuScript

;
; PAGE Templates ----------------------------------------------------------------------------------
;

Function generateTemplatesPage()
	SetCursorFillMode(TOP_TO_BOTTOM)

	AddHeaderOption("$RRCasualTemplates", _modEnabledFlags)

	AddTextOptionST("TEMPLATE_CASUAL_WARRIOR", "$RRWarrior", "$Apply", _modEnabledFlags)
	AddTextOptionST("TEMPLATE_CASUAL_MAGE", "$RRMage", "$Apply", _modEnabledFlags)
	AddTextOptionST("TEMPLATE_CASUAL_THIEF", "$RRThief", "$Apply", _modEnabledFlags)
	AddEmptyOption()

	AddHeaderOption("$RRRealisticTemplates", _modEnabledFlags)
	AddTextOptionST("TEMPLATE_REAL_ULTIMATE", "$RRUltimate", "$Apply", _modEnabledFlags)
	AddTextOptionST("TEMPLATE_REAL_DAGGERFALL", "$RRDaggerfall", "$Apply", _modEnabledFlags)

	SetCursorPosition(1)

	AddHeaderOption("$RRSpecialTemplates", _modEnabledFlags)
	AddTextOptionST("TEMPLATE_SPEC_CLEAN", "$RRCleanTemplate", "$Apply", _modEnabledFlags)
	AddTextOptionST("RESTORE_GAME_SETTINGS", "$RRRestoreGameSettings", "$Apply", _modEnabledFlags)
	AddEmptyOption()

	AddHeaderOption("$RRCompabilityTemplates", _modEnabledFlags)
	AddTextOptionST("TEMPLATE_COMP_REQUIEM", "$RRRequiemTemplate", "$Apply", _modEnabledFlags)
endFunction

;
; STATE Templates ---------------------------------------------------------------------------------
;
; STATE Templates : Text --------------------------------------------------------------------------
;

state TEMPLATE_CASUAL_WARRIOR ; Text
	event OnSelectST()
		if (ShowMessage("$RRTemplateWarning"))
			RRTemplates.CasualWarrior()
			ShowMessage("$RRMsgReady")
		endIf
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintWarrior")
	endEvent
endState

state TEMPLATE_CASUAL_MAGE ; Text
	event OnSelectST()
		if (ShowMessage("$RRTemplateWarning"))
			RRTemplates.CasualMage()
			ShowMessage("$RRMsgReady")
		endIf
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintMage")
	endEvent
endState

state TEMPLATE_CASUAL_THIEF ; Text
	event OnSelectST()
		if (ShowMessage("$RRTemplateWarning"))
			RRTemplates.CasualThief()
			ShowMessage("$RRMsgReady")
		endIf
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintThief")
	endEvent
endState

state TEMPLATE_SPEC_CLEAN ; Text
	event OnSelectST()
		if (ShowMessage("$RRTemplateWarning"))
			RRTemplates.CleanTemplate()
			ShowMessage("$RRMsgReady")
		endIf
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintCleanTemplate")
	endEvent
endState

state RESTORE_GAME_SETTINGS ; Text
	event OnSelectST()
		if (ShowMessage("$RRTemplateWarning"))
			RRTemplates.RestoreGameSettings()
			ShowMessage("$RRMsgReady")
		endIf
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintRestoreGameSettings")
	endEvent
endState

state TEMPLATE_COMP_REQUIEM ; Text
	event OnSelectST()
		if (ShowMessage("$RRTemplateWarning"))
			RRTemplates.RequiemTemplate()
			ShowMessage("$RRMsgReady")
		endIf
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintRequiemTemplate")
	endEvent
endState

state TEMPLATE_REAL_ULTIMATE ; Text
	event OnSelectST()
		if (ShowMessage("$RRTemplateWarning"))
			RRTemplates.UltimateTemplate()
			ShowMessage("$RRMsgReady")
		endIf
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintUltimateTemplate")
	endEvent
endState

state TEMPLATE_REAL_DAGGERFALL ; Text
	event OnSelectST()
		if (ShowMessage("$RRTemplateWarning"))
			RRTemplates.DaggerfallTemplate()
			ShowMessage("$RRMsgReady")
		endIf
	endEvent

	event OnHighlightST()
		SetInfoText("$RRhintDaggerfallTemplate")
	endEvent
endState

;
; FUNCTIONS : Templates ---------------------------------------------------------------------------
;

Function updateTemplatesFlags()
	updateModEnabledFlags()
endFunction
