Scriptname RRControlScript extends Quest  


Actor Property PlayerREF Auto

GlobalVariable Property RREnabled Auto
GlobalVariable Property RRUninstall Auto

GlobalVariable Property RRHealEnabled Auto
GlobalVariable Property RRMagickaEnabled Auto
GlobalVariable Property RRStaminaEnabled Auto

; Debug

GlobalVariable Property RRDebugEnabled Auto

; Default

GlobalVariable Property RRHealRateIndex Auto
GlobalVariable Property RRHealRate Auto

GlobalVariable Property RRMagickaRateIndex Auto
GlobalVariable Property RRMagickaRate Auto

GlobalVariable Property RRStaminaRateIndex Auto
GlobalVariable Property RRStaminaRate Auto

; Sleep

GlobalVariable Property RRSleepHealIndex Auto
GlobalVariable Property RRSleepHealValue Auto

GlobalVariable Property RRSleepMagickaIndex Auto
GlobalVariable Property RRSleepMagickaValue Auto

GlobalVariable Property RRSleepStaminaIndex Auto
GlobalVariable Property RRSleepStaminaValue Auto

; Sitting (MagicEffect)

Spell Property RRSittingHealRateSpell Auto 
GlobalVariable Property RRSittingHealIndex Auto
GlobalVariable Property RRSittingHealValue Auto

Spell Property RRSittingMagickaRateSpell Auto 
GlobalVariable Property RRSittingMagickaIndex Auto
GlobalVariable Property RRSittingMagickaValue Auto

Spell Property RRSittingStaminaRateSpell Auto 
GlobalVariable Property RRSittingStaminaIndex Auto
GlobalVariable Property RRSittingStaminaValue Auto

; Running (MagicEffect)

Spell Property RRRunningHealRateSpell Auto 
GlobalVariable Property RRRunningHealIndex Auto
GlobalVariable Property RRRunningHealValue Auto

Spell Property RRRunningMagickaRateSpell Auto 
GlobalVariable Property RRRunningMagickaIndex Auto
GlobalVariable Property RRRunningMagickaValue Auto

Spell Property RRRunningStaminaRateSpell Auto 
GlobalVariable Property RRRunningStaminaIndex Auto
GlobalVariable Property RRRunningStaminaValue Auto

; Sprint (MagicEffect)

Spell Property RRSprintHealRateSpell Auto 
GlobalVariable Property RRSprintHealIndex Auto
GlobalVariable Property RRSprintHealValue Auto

Spell Property RRSprintMagickaRateSpell Auto 
GlobalVariable Property RRSprintMagickaIndex Auto
GlobalVariable Property RRSprintMagickaValue Auto

Spell Property RRSprintStaminaRateSpell Auto 
GlobalVariable Property RRSprintStaminaIndex Auto
GlobalVariable Property RRSprintStaminaValue Auto

; Potion (MagicEffect)

Spell Property RRPotionRegenHealRateSpell Auto 
GlobalVariable Property RRPotionRegenHealIndex Auto
GlobalVariable Property RRPotionRegenHealValue Auto

Spell Property RRPotionRegenMagickaRateSpell Auto 
GlobalVariable Property RRPotionRegenMagickaIndex Auto
GlobalVariable Property RRPotionRegenMagickaValue Auto

Spell Property RRPotionRegenStaminaRateSpell Auto 
GlobalVariable Property RRPotionRegenStaminaIndex Auto
GlobalVariable Property RRPotionRegenStaminaValue Auto

; Food (MagicEffect)

Spell Property RRFoodHealRateSpell Auto 
GlobalVariable Property RRFoodHealIndex Auto
GlobalVariable Property RRFoodHealValue Auto

Spell Property RRFoodMagickaRateSpell Auto 
GlobalVariable Property RRFoodMagickaIndex Auto
GlobalVariable Property RRFoodMagickaValue Auto

Spell Property RRFoodStaminaRateSpell Auto 
GlobalVariable Property RRFoodStaminaIndex Auto
GlobalVariable Property RRFoodStaminaValue Auto

; Combat

GlobalVariable Property RRCombatMultHealIndex Auto
GlobalVariable Property RRCombatMultHealValue Auto

GlobalVariable Property RRCombatMultMagickaIndex Auto
GlobalVariable Property RRCombatMultMagickaValue Auto

GlobalVariable Property RRCombatMultStaminaIndex Auto
GlobalVariable Property RRCombatMultStaminaValue Auto

Spell Property RRCombatHealRateSpell Auto 
GlobalVariable Property RRCombatHealIndex Auto
GlobalVariable Property RRCombatHealValue Auto

Spell Property RRCombatMagickaRateSpell Auto 
GlobalVariable Property RRCombatMagickaIndex Auto
GlobalVariable Property RRCombatMagickaValue Auto

Spell Property RRCombatStaminaRateSpell Auto 
GlobalVariable Property RRCombatStaminaIndex Auto
GlobalVariable Property RRCombatStaminaValue Auto

; Items

Spell Property RRItemsHealRateSpell Auto 
GlobalVariable Property RRItemsHealIndex Auto
GlobalVariable Property RRItemsHealValue Auto

Spell Property RRItemsMagickaRateSpell Auto 
GlobalVariable Property RRItemsMagickaIndex Auto
GlobalVariable Property RRItemsMagickaValue Auto

Spell Property RRItemsStaminaRateSpell Auto 
GlobalVariable Property RRItemsStaminaIndex Auto
GlobalVariable Property RRItemsStaminaValue Auto

; Spells

Spell Property RRSpellsHealRateSpell Auto 
GlobalVariable Property RRSpellsHealIndex Auto
GlobalVariable Property RRSpellsHealValue Auto

Spell Property RRSpellsMagickaRateSpell Auto 
GlobalVariable Property RRSpellsMagickaIndex Auto
GlobalVariable Property RRSpellsMagickaValue Auto

Spell Property RRSpellsStaminaRateSpell Auto 
GlobalVariable Property RRSpellsStaminaIndex Auto
GlobalVariable Property RRSpellsStaminaValue Auto

; Wait

GlobalVariable Property RRWaitHealIndex Auto
GlobalVariable Property RRWaitHealValue Auto

GlobalVariable Property RRWaitMagickaIndex Auto
GlobalVariable Property RRWaitMagickaValue Auto

GlobalVariable Property RRWaitStaminaIndex Auto
GlobalVariable Property RRWaitStaminaValue Auto

; Misc

GlobalVariable Property RRUpdateSpellsAt Auto
GlobalVariable Property RRHideInUI Auto

; Constants
GlobalVariable Property RRFunctionNoHeal Auto
GlobalVariable Property RRFunctionDefault Auto
GlobalVariable Property RRFunctionUserDefined Auto
GlobalVariable Property RRFunctionVanilla Auto

; Perks
GlobalVariable Property RREagleEyeStaminaEnabled Auto
GlobalVariable Property RREagleEyeStaminaValue Auto
Perk Property EagleEye30 Auto

; Specialties
GlobalVariable Property RRPerkSlowEnabled Auto
Spell Property RRPerkSlowSpell Auto


; PRIVATE VARIABLES -------------------------------------------------------------------------------

float Property defaultHealRate = 0.7 autoReadOnly
float Property defaultMagickaRate = 3.0 autoReadOnly
float Property defaultStaminaRate = 5.0 autoReadOnly

float Property defaultCombatHealMult = 0.7 autoReadOnly
float Property defaultCombatMagickaMult = 0.33 autoReadOnly
float Property defaultCombatStaminaMult = 0.35 autoReadOnly

int Property Detrimental = 0x00000004 autoReadOnly
int Property HideInUI = 0x00008000 autoReadOnly

string[]            rateNamesList
GlobalVariable[]    rateValueList
GlobalVariable[]    rateIndexList
GlobalVariable[]    enabledList
float[]             defaultList
float[]             defaultCombatMultList
string[]            rateMultNamesList

GlobalVariable[]    sittingIndexList
GlobalVariable[]    sittingValueList
Spell[]             sittingSpellList
bool[]              sittingToAddList

GlobalVariable[]    runningIndexList
GlobalVariable[]    runningValueList
Spell[]             runningSpellList
bool[]              runningToAddList

GlobalVariable[]    sprintIndexList
GlobalVariable[]    sprintValueList
Spell[]             sprintSpellList
bool[]              sprintToAddList

GlobalVariable[]    potionsIndexList
GlobalVariable[]    potionsValueList
Spell[]             potionsSpellList
bool[]              potionsToAddList

GlobalVariable[]    foodIndexList
GlobalVariable[]    foodValueList
Spell[]             foodSpellList
bool[]              foodToAddList

GlobalVariable[]    combatIndexList
GlobalVariable[]    combatValueList
Spell[]             combatSpellList
bool[]              combatToAddList

GlobalVariable[]    itemsIndexList
GlobalVariable[]    itemsValueList
Spell[]             itemsSpellList
bool[]              itemsToAddList

GlobalVariable[]    spellsIndexList
GlobalVariable[]    spellsValueList
Spell[]             spellsSpellList
bool[]              spellsToAddList

string[]            avNamesList
GlobalVariable[]    functionIndexesList
GlobalVariable[]    functionValuesList
string[]            functionNamesList

string[]            combatMultNamesList

float[]             defaultWerewolfRateList


GlobalVariable[]    specialIndexList
Spell[]             specialSpellList


;
; FUNCTIONS ---------------------------------------------------------------------------------------
;

Function initializeVariables()
	functionIndexesList = new GlobalVariable[6]
	functionIndexesList[0] = RRSleepHealIndex
	functionIndexesList[1] = RRSleepMagickaIndex
	functionIndexesList[2] = RRSleepStaminaIndex
	functionIndexesList[3] = RRWaitHealIndex
	functionIndexesList[4] = RRWaitMagickaIndex
	functionIndexesList[5] = RRWaitStaminaIndex

	functionValuesList = new GlobalVariable[6]
	functionValuesList[0] = RRSleepHealValue
	functionValuesList[1] = RRSleepMagickaValue
	functionValuesList[2] = RRSleepStaminaValue
	functionValuesList[3] = RRWaitHealValue
	functionValuesList[4] = RRWaitMagickaValue
	functionValuesList[5] = RRWaitStaminaValue

	functionNamesList = new string[2]
	functionNamesList[0] = "Sleep"
	functionNamesList[1] = "Wait"

	avNamesList = new string[3]
	avNamesList[0] = "Health"
	avNamesList[1] = "Magicka"
	avNamesList[2] = "Stamina"
;
; ---
;
	rateNamesList = new string[3]
	rateNamesList[0] = "HealRate"
	rateNamesList[1] = "MagickaRate"
	rateNamesList[2] = "StaminaRate"

	rateMultNamesList = new string[3]
	rateMultNamesList[0] = "HealRateMult"
	rateMultNamesList[1] = "MagickaRateMult"
	rateMultNamesList[2] = "StaminaRateMult"

	rateIndexList = new GlobalVariable[3]
	rateIndexList[0] = RRHealRateIndex
	rateIndexList[1] = RRMagickaRateIndex
	rateIndexList[2] = RRStaminaRateIndex

	rateValueList = new GlobalVariable[3]
	rateValueList[0] = RRHealRate
	rateValueList[1] = RRMagickaRate
	rateValueList[2] = RRStaminaRate

	enabledList = new GlobalVariable[3]
	enabledList[0] = RRHealEnabled
	enabledList[1] = RRMagickaEnabled
	enabledList[2] = RRStaminaEnabled

	defaultList = new float[3]
	defaultList[0] = defaultHealRate
	defaultList[1] = defaultMagickaRate
	defaultList[2] = defaultStaminaRate

	defaultCombatMultList = new float[3]
	defaultCombatMultList[0] = defaultCombatHealMult
	defaultCombatMultList[1] = defaultCombatMagickaMult
	defaultCombatMultList[2] = defaultCombatStaminaMult

	combatMultNamesList = new string[3]
	combatMultNamesList[0] = "CombatHealthRegenMult" ; player.XXX
	combatMultNamesList[1] = "fCombatMagickaRegenRateMult" ; Game.XXX
	combatMultNamesList[2] = "fCombatStaminaRegenRateMult" ; Game.XXX

	; Sitting

	sittingIndexList = new GlobalVariable[3]
	sittingIndexList[0] = RRSittingHealIndex
	sittingIndexList[1] = RRSittingMagickaIndex
	sittingIndexList[2] = RRSittingStaminaIndex

	sittingValueList = new GlobalVariable[3]
	sittingValueList[0] = RRSittingHealValue
	sittingValueList[1] = RRSittingMagickaValue
	sittingValueList[2] = RRSittingStaminaValue

	sittingSpellList = new Spell[3]
	sittingSpellList[0] = RRSittingHealRateSpell
	sittingSpellList[1] = RRSittingMagickaRateSpell
	sittingSpellList[2] = RRSittingStaminaRateSpell

	sittingToAddList = new Bool[3]
	sittingToAddList[0] = false
	sittingToAddList[1] = false
	sittingToAddList[2] = false

	; Running

	runningIndexList = new GlobalVariable[3]
	runningIndexList[0] = RRRunningHealIndex
	runningIndexList[1] = RRRunningMagickaIndex
	runningIndexList[2] = RRRunningStaminaIndex

	runningValueList = new GlobalVariable[3]
	runningValueList[0] = RRRunningHealValue
	runningValueList[1] = RRRunningMagickaValue
	runningValueList[2] = RRRunningStaminaValue

	runningSpellList = new Spell[3]
	runningSpellList[0] = RRRunningHealRateSpell
	runningSpellList[1] = RRRunningMagickaRateSpell
	runningSpellList[2] = RRRunningStaminaRateSpell

	runningToAddList = new Bool[3]
	runningToAddList[0] = false
	runningToAddList[1] = false
	runningToAddList[2] = false

	; Sprint

	sprintIndexList = new GlobalVariable[3]
	sprintIndexList[0] = RRSprintHealIndex
	sprintIndexList[1] = RRSprintMagickaIndex
	sprintIndexList[2] = RRSprintStaminaIndex

	sprintValueList = new GlobalVariable[3]
	sprintValueList[0] = RRSprintHealValue
	sprintValueList[1] = RRSprintMagickaValue
	sprintValueList[2] = RRSprintStaminaValue

	sprintSpellList = new Spell[3]
	sprintSpellList[0] = RRSprintHealRateSpell
	sprintSpellList[1] = RRSprintMagickaRateSpell
	sprintSpellList[2] = RRSprintStaminaRateSpell

	sprintToAddList = new Bool[3]
	sprintToAddList[0] = false
	sprintToAddList[1] = false
	sprintToAddList[2] = false

	; Potion

	potionsIndexList = new GlobalVariable[3]
	potionsIndexList[0] = RRPotionRegenHealIndex
	potionsIndexList[1] = RRPotionRegenMagickaIndex
	potionsIndexList[2] = RRPotionRegenStaminaIndex

	potionsValueList = new GlobalVariable[3]
	potionsValueList[0] = RRPotionRegenHealValue
	potionsValueList[1] = RRPotionRegenMagickaValue
	potionsValueList[2] = RRPotionRegenStaminaValue

	potionsSpellList = new Spell[3]
	potionsSpellList[0] = RRPotionRegenHealRateSpell
	potionsSpellList[1] = RRPotionRegenMagickaRateSpell
	potionsSpellList[2] = RRPotionRegenStaminaRateSpell

	potionsToAddList = new Bool[3]
	potionsToAddList[0] = false
	potionsToAddList[1] = false
	potionsToAddList[2] = false
	
	; Food

	foodIndexList = new GlobalVariable[3]
	foodIndexList[0] = RRFoodHealIndex
	foodIndexList[1] = RRFoodMagickaIndex
	foodIndexList[2] = RRFoodStaminaIndex

	foodValueList = new GlobalVariable[3]
	foodValueList[0] = RRFoodHealValue
	foodValueList[1] = RRFoodMagickaValue
	foodValueList[2] = RRFoodStaminaValue

	foodSpellList = new Spell[3]
	foodSpellList[0] = RRFoodHealRateSpell
	foodSpellList[1] = RRFoodMagickaRateSpell
	foodSpellList[2] = RRFoodStaminaRateSpell

	foodToAddList = new Bool[3]
	foodToAddList[0] = false
	foodToAddList[1] = false
	foodToAddList[2] = false

	; Combat

	combatIndexList = new GlobalVariable[3]
	combatIndexList[0] = RRCombatHealIndex
	combatIndexList[1] = RRCombatMagickaIndex
	combatIndexList[2] = RRCombatStaminaIndex

	combatValueList = new GlobalVariable[3]
	combatValueList[0] = RRCombatHealValue
	combatValueList[1] = RRCombatMagickaValue
	combatValueList[2] = RRCombatStaminaValue

	combatSpellList = new Spell[3]
	combatSpellList[0] = RRCombatHealRateSpell
	combatSpellList[1] = RRCombatMagickaRateSpell
	combatSpellList[2] = RRCombatStaminaRateSpell

	combatToAddList = new Bool[3]
	combatToAddList[0] = false
	combatToAddList[1] = false
	combatToAddList[2] = false

	; Items

	itemsIndexList = new GlobalVariable[3]
	itemsIndexList[0] = RRItemsHealIndex
	itemsIndexList[1] = RRItemsMagickaIndex
	itemsIndexList[2] = RRItemsStaminaIndex

	itemsValueList = new GlobalVariable[3]
	itemsValueList[0] = RRItemsHealValue
	itemsValueList[1] = RRItemsMagickaValue
	itemsValueList[2] = RRItemsStaminaValue

	itemsSpellList = new Spell[3]
	itemsSpellList[0] = RRItemsHealRateSpell
	itemsSpellList[1] = RRItemsMagickaRateSpell
	itemsSpellList[2] = RRItemsStaminaRateSpell

	itemsToAddList = new Bool[3]
	itemsToAddList[0] = false
	itemsToAddList[1] = false
	itemsToAddList[2] = false

	; Spells

	spellsIndexList = new GlobalVariable[3]
	spellsIndexList[0] = RRSpellsHealIndex
	spellsIndexList[1] = RRSpellsMagickaIndex
	spellsIndexList[2] = RRSpellsStaminaIndex

	spellsValueList = new GlobalVariable[3]
	spellsValueList[0] = RRSpellsHealValue
	spellsValueList[1] = RRSpellsMagickaValue
	spellsValueList[2] = RRSpellsStaminaValue

	spellsSpellList = new Spell[3]
	spellsSpellList[0] = RRSpellsHealRateSpell
	spellsSpellList[1] = RRSpellsMagickaRateSpell
	spellsSpellList[2] = RRSpellsStaminaRateSpell

	spellsToAddList = new Bool[3]
	spellsToAddList[0] = false
	spellsToAddList[1] = false
	spellsToAddList[2] = false

	defaultWerewolfRateList = new float[3]
	defaultWerewolfRateList[0] = 0.0  ; heal rate
	defaultWerewolfRateList[1] = 3.0  ; magicka rate
	defaultWerewolfRateList[2] = 20.0 ; stamina rate

	; Special Spells
	specialIndexList = new GlobalVariable[1]
	specialIndexList[0] = RRPerkSlowEnabled

	specialSpellList = new Spell[1]
	specialSpellList[0] = RRPerkSlowSpell
endFunction

int Function getAVIndexByName( string avName )
	return avNamesList.Find( avName )
endFunction

float Function getCurrentRateByIndex( int iIndex )
	if ( iIndex >= 0 && iIndex <= 2 )
		return PlayerREF.GetActorValue( rateNamesList[iIndex] )
	else
		return -1.0
	endIf
endFunction

float Function getCurrentRateMultByIndex( int iIndex )
	if ( iIndex >= 0 && iIndex <= 2 )
		return PlayerREF.GetActorValue( rateMultNamesList[iIndex] )
	else
		return -1.0
	endIf
endFunction

float Function getCurrentCombatRateMultByIndex( int iIndex )
	if ( iIndex >= 0 && iIndex <= 2 )
		if ( iIndex == 0 )
			return PlayerREF.GetActorValue( combatMultNamesList[iIndex] )
		else
			return Game.GetGameSettingFloat( combatMultNamesList[iIndex] )
		endIf
	else
		return -1.0
	endIf
endFunction

float Function getCurrentAttrByIndex( int iIndex )
	if ( iIndex >= 0 && iIndex <= 2 )
		return PlayerREF.GetActorValue( avNamesList[iIndex] )
	else
		return -1.0
	endIf
endFunction

int Function getFunctionType( string fName, string avName )
	int avIndex = avNamesList.Find( avName )
	int fnIndex = functionNamesList.Find( fName )

	if ( avIndex == -1 || fnIndex == -1 )
		Debug.Notification( "RRControl.getFunctionType(): invalid values passed: " )
		Debug.Notification( "Function: " + fName )
		Debug.Notification( "avName: " + avName )
		return RRFunctionVanilla.GetValueInt()
	endif
	
	int ftIndex = (fnIndex * 3) + avIndex

	return functionIndexesList[ftIndex].GetValueInt()
endFunction

float Function getRateValue( string avName )
	int avIndex = avNamesList.Find( avName )

	if ( avIndex == -1 )
		Debug.Notification( "RRControl.getRateValue(): invalid value: " + avName )
		return 0.0
	endif

	return rateValueList[avIndex].GetValue()
endFunction

float Function getRateByType( string fName, string avName )
	int avIndex = avNamesList.Find( avName )
	int fnIndex = functionNamesList.Find( fName )

	if ( avIndex == -1 || fnIndex == -1 )
		Debug.Notification( "RRControl.getValueByType(): invalid values passed: " )
		Debug.Notification( "Function: " + fName )
		Debug.Notification( "avName: " + avName )
		return -1
	endif
	
	int ftIndex = (fnIndex * 3) + avIndex

	return functionValuesList[ftIndex].GetValue()
endFunction

string Function getRateNameByAVName( string avName )
	int avIndex = avNamesList.Find( avName )

	if ( avIndex == -1 )
		Debug.Notification( "RRControl.getRateNameByAVName(): invalid value: " + avName )
		return ""
	endif

	return rateNamesList[avIndex]
endFunction

float Function getDefaultRate( string avName )
	int avIndex = avNamesList.Find( avName )

	if ( avIndex == -1 )
		Debug.Notification( "RRControl.getDefaultRate(): invalid value: " + avName )
		return -1.0
	endif

	return defaultList[avIndex]
endFunction

float Function getDefaultWerewolfRate( string avName )
	int avIndex = avNamesList.Find( avName )

	if ( avIndex == -1 )
		Debug.Notification( "RRControl.getDefaultWerewolfRate(): invalid value: " + avName )
		return -1.0
	endif

	return defaultWerewolfRateList[avIndex]
endFunction

;
; getDRCombatMult - Get Default Rate Combat Multiplier
;
float Function getDRCombatMult( string avName )
	int avIndex = avNamesList.Find( avName )

	if ( avIndex == -1 )
		Debug.Notification( "RRControl.getDRCombatMult(): invalid value: " + avName )
		return -1.0
	endif

	return defaultCombatMultList[avIndex]
endFunction

float Function getCurrentCombatMult( string avName )
	int avIndex = avNamesList.Find( avName )

	if ( avIndex < 0 )
		Debug.Notification( "RRControl.getCurrentCombatMult(): invalid value: " + avName )
		return -1.0
	elseif ( avIndex == 0 ) ; combat health mult rate calculates differently
		return PlayerREF.GetAV( combatMultNamesList[avIndex] )
	else ; magicka and stamina combat mult rates are game settings values
		return Game.GetGameSettingFloat( combatMultNamesList[avIndex] )
	endIf
endFunction

bool Function isRRAVEnabled( string avName )
	int avIndex = avNamesList.Find( avName )

	if ( avIndex == -1 )
		Debug.Notification( "RRControl.isRRAVEnabled(): invalid value: " + avName )
		return false
	endif

	if ( isActive() )
		return enabledList[avIndex] != none && enabledList[avIndex].GetValueInt() == 1
	else
		return false
	endif
endFunction

bool Function isActive()
	return RREnabled != none && RREnabled.GetValueInt() == 1
EndFunction

bool Function isDebug()
	return RRDebugEnabled != none && RRDebugEnabled.GetValueInt() == 1
EndFunction

Function reset()
	if ( isActive() )
		activate()
	else
		deactivate()
	endif
endFunction

Function activate()
	removeAllSpells()
	setPlayerSettings()
	setPerkValues()

	GotoState( "onAddSpells" )
	RegisterForSingleUpdate( RRUpdateSpellsAt.GetValue() )
endFunction

Function deactivate()
	UnregisterForUpdate()
	restoreDefaultSettings()
endFunction

Function setPlayerSettings()
	setCombatMultipliers()

	int avIndex = 0
	While( avIndex < rateNamesList.Length )
		if ( enabledList[avIndex].GetValue() == 1 )
			setPlayerRate( rateNamesList[avIndex] )
		endIf

		avIndex += 1
	endWhile
endFunction

Function setPerkValues()
	; Eagle Eye Perk
	if ( RREagleEyeStaminaEnabled.GetValueInt() == 1 )
		SetPerkValueByPriority( EagleEye30, 15, RREagleEyeStaminaValue.GetValue() )

		if isDebug()
			Debug.Notification("Eagle Eye Stamina Drain Value: " + RREagleEyeStaminaValue.GetValue())
		endIf
	endIf
endFunction

Function setCombatMultipliers()
	if ( RRHealEnabled.GetValue() == 1 )
		int typeIndex = RRCombatMultHealIndex.GetValueInt()
		string avName = "CombatHealthRegenMult"

		if ( typeIndex == RRFunctionNoHeal.GetValueInt() ) ; don't regenerate
			PlayerREF.ForceAV( avName , 0.0 )
		elseif ( typeIndex == RRFunctionUserDefined.GetValueInt() ) ; user defined
			PlayerREF.ForceAV( avName , RRCombatMultHealValue.GetValue() )
		elseif ( typeIndex == RRFunctionDefault.GetValueInt() )
			PlayerREF.ForceAV( avName, defaultCombatHealMult )
		else ; vanilla
			; nop
		endIf
	endIf

	if ( RRMagickaEnabled.GetValue() == 1 )
		int typeIndex = RRCombatMultMagickaIndex.GetValueInt()
		string avName = "fCombatMagickaRegenRateMult"

		if ( typeIndex == RRFunctionNoHeal.GetValueInt() ) ; don't regenerate
			Game.SetGameSettingFloat( avName, 0.0 )
		elseif ( typeIndex == RRFunctionUserDefined.GetValueInt() ) ; user defined
			Game.SetGameSettingFloat( avName, RRCombatMultMagickaValue.GetValue() )
		elseif ( typeIndex == RRFunctionDefault.GetValueInt() )
			Game.SetGameSettingFloat( avName, defaultCombatMagickaMult )
		else ; vanilla
			; nop
		endIf
	endIf

	if ( RRStaminaEnabled.GetValue() == 1 )
		int typeIndex = RRCombatMultMagickaIndex.GetValueInt()
		string avName = "fCombatStaminaRegenRateMult"

		if ( typeIndex == RRFunctionNoHeal.GetValueInt() ) ; don't regenerate
			Game.SetGameSettingFloat( avName, 0.0 )
		elseif ( typeIndex == RRFunctionUserDefined.GetValueInt() ) ; user defined
			Game.SetGameSettingFloat( avName, RRCombatMultStaminaValue.GetValue() )
		elseif ( typeIndex == RRFunctionDefault.GetValueInt() )
			Game.SetGameSettingFloat( avName, defaultCombatStaminaMult )
		else ; vanilla
			; nop
		endIf
	endIf
endFunction

Function setPlayerRate(string avName)
	int avIndex = rateNamesList.Find(avName)
	int svIndex
	float newRate
	Spell avSpell

	; Sitting

	svIndex = sittingIndexList[avIndex].GetValueInt()
	newRate = sittingValueList[avIndex].GetValue()
	avSpell = sittingSpellList[avIndex]

	sittingToAddList[avIndex] = setThisSpell(avName, svIndex, newRate, avSpell)

	; Running

	svIndex = runningIndexList[avIndex].GetValueInt()
	newRate = runningValueList[avIndex].GetValue()
	avSpell = runningSpellList[avIndex]

	runningToAddList[avIndex] = setThisSpell(avName, svIndex, newRate, avSpell)

	; Sprint

	svIndex = sprintIndexList[avIndex].GetValueInt()
	newRate = sprintValueList[avIndex].GetValue()
	avSpell = sprintSpellList[avIndex]

	sprintToAddList[avIndex] = setThisSpell(avName, svIndex, newRate, avSpell)

	; Potions

	svIndex = potionsIndexList[avIndex].GetValueInt()
	newRate = potionsValueList[avIndex].GetValue()
	avSpell = potionsSpellList[avIndex]

	potionsToAddList[avIndex] = setThisSpell(avName, svIndex, newRate, avSpell)

	; Food

	svIndex = foodIndexList[avIndex].GetValueInt()
	newRate = foodValueList[avIndex].GetValue()
	avSpell = foodSpellList[avIndex]

	foodToAddList[avIndex] = setThisSpell(avName, svIndex, newRate, avSpell)

	; Combat

	svIndex = combatIndexList[avIndex].GetValueInt()
	newRate = combatValueList[avIndex].GetValue()
	avSpell = combatSpellList[avIndex]

	combatToAddList[avIndex] = setThisSpell(avName, svIndex, newRate, avSpell)

	; Items

	svIndex = itemsIndexList[avIndex].GetValueInt()
	newRate = itemsValueList[avIndex].GetValue()
	avSpell = itemsSpellList[avIndex]

	itemsToAddList[avIndex] = setThisSpell(avName, svIndex, newRate, avSpell)

	; Spells

	svIndex = spellsIndexList[avIndex].GetValueInt()
	newRate = spellsValueList[avIndex].GetValue()
	avSpell = spellsSpellList[avIndex]

	spellsToAddList[avIndex] = setThisSpellASIS(avName, svIndex, newRate, avSpell)

	; Do not forget update player actor value too!
	;
	setStaticRate( avName )
endFunction

; setThisSpellASIS -- added in 3.09
;
; The difference between setThisSpellASIS() and setThisSpell() is that
; this version does NOT take in account "default" rate.
; Specially created for Abilities and Perks: Akatosh Blessing, Wind Walker, Lady Sign and Namira's Ring
;
Bool Function setThisSpellASIS( string avName, int iFunction, float fUserRate, Spell aSpell )
	if ( PlayerREF.HasSpell( aSpell ) )
		PlayerREF.RemoveSpell( aSpell )
	endif

	float fNewRate

	if ( iFunction == RRFunctionUserDefined.GetValueInt() )
		fNewRate = fUserRate
	elseif ( iFunction == RRFunctionNoHeal.GetValueInt() )
		fNewRate = 0.000000
	elseif ( iFunction == RRFunctionDefault.GetValueInt() )
		int avIndex = rateNamesList.Find( avName )
		fNewRate = defaultList[avIndex]
	else ; vanilla
		; nothing to do
		;
		return false
	endIf

	; update flags
	MagicEffect spellEffect = aSpell.GetNthEffectMagicEffect( 0 )

	if ( fUserRate > 0.0 ) ; increase
		if ( spellEffect.IsEffectFlagSet( Detrimental ) )
			spellEffect.ClearEffectFlag( Detrimental )
		endIf
	else
		if ( !spellEffect.IsEffectFlagSet( Detrimental ) )
			spellEffect.SetEffectFlag( Detrimental )
		endIf
	endIf
	
	if ( RRHideInUI.GetValueInt() == 1 )
		if ( !spellEffect.IsEffectFlagSet( HideInUI ) )
			spellEffect.SetEffectFlag( HideInUI )
		endIf
	else
		if ( spellEffect.IsEffectFlagSet( HideInUI ) )
			spellEffect.ClearEffectFlag( HideInUI )
		endIf
	endIf

	; set new magnitude
	aSpell.SetNthEffectMagnitude( 0, Math.abs( fUserRate ) )

	if ( isDebug() )
		Debug.Notification( aSpell.GetName() + " magnitude: " + fUserRate )
	endIf

	; needed to add spell
	return true
endFunction

Bool Function setThisSpell( string avName, int iFunction, float fUserRate, Spell aSpell )
	if ( PlayerREF.HasSpell( aSpell ) )
		PlayerREF.RemoveSpell( aSpell )
	endif

	if ( iFunction == RRFunctionUserDefined.GetValueInt() )
		setEffectMagnitude( avName, fUserRate, aSpell )
	elseif ( iFunction == RRFunctionNoHeal.GetValueInt() )
		setEffectMagnitude( avName, 0.0, aSpell )
	elseif ( iFunction == RRFunctionDefault.GetValueInt() )
		int avIndex = rateNamesList.Find( avName )
		setEffectMagnitude( avName, defaultList[avIndex], aSpell )
	else ; vanilla
		; nothing to do
		;
		return false
	endIf

	; needed to add spell
	return true
endFunction

Function setEffectMagnitude( string avName, float userRate, Spell aSpell )
	float currentRate = getCurrentRate( avName )

	if ( currentRate < 0.0 )
		; staying/default regeneration rate is disabled
		; use base actor value instead
		currentRate = PlayerREF.GetBaseActorValue( avName )
	endif

	float effectRate = userRate - currentRate
	MagicEffect spellEffect = aSpell.GetNthEffectMagicEffect( 0 )

	if ( effectRate > 0.0 ) ; increase
		if ( spellEffect.IsEffectFlagSet( Detrimental ) )
			spellEffect.ClearEffectFlag( Detrimental )
		endIf
	else
		if ( !spellEffect.IsEffectFlagSet( Detrimental ) )
			spellEffect.SetEffectFlag( Detrimental )
		endIf
	endIf
	
	if ( RRHideInUI.GetValueInt() == 1 )
		if ( !spellEffect.IsEffectFlagSet( HideInUI ) )
			spellEffect.SetEffectFlag( HideInUI )
		endIf
	else
		if ( spellEffect.IsEffectFlagSet( HideInUI ) )
			spellEffect.ClearEffectFlag( HideInUI )
		endIf
	endIf

	if ( isDebug() )
		Debug.Notification( aSpell.GetName() + " magnitude: " + effectRate )
	endIf

	aSpell.SetNthEffectMagnitude( 0, Math.abs( effectRate ) )
endFunction

Function setStaticRate( string avName, bool forceDefault = false )
	float newRate = getCurrentRate( avName )

	if ( forceDefault )
		int index = rateNamesList.Find( avName )
		PlayerREF.ForceAV( avName, defaultList[index] )
	elseif ( newRate < 0.000000 )
		; nop
		return
	else
		PlayerREF.ForceAV( avName, newRate )
	endif
endFunction

float Function getCurrentRate( string avName )
	int iIndex = rateNamesList.Find( avName )
	int iState = getRateFunctionByName( avName )

	if ( iState == RRFunctionNoHeal.GetValueInt() ) ; no regen
		return 0.0
	elseif ( iState == RRFunctionUserDefined.GetValueInt() ) ; user defined
		return rateValueList[iIndex].GetValue()
	elseif ( iState == RRFunctionDefault.GetValueInt() )
		return defaultList[iIndex]
	else ; vanilla (disabled)
		;
		; Note: Everything said below means by settings are values for:
		;	* RRHealRateIndex
		;	* RRMagickaRateIndex
		;	* RRStaminaRateIndex
		;
		; In 2.10 version I had to recovered "Vanilla" (called as DISABLED) 
		; type for them, but I know that they will bring such 
		; type of problems as described below.
		;
		;
		; Issue #1:  User set uped non-vanilla type's value. Later, (s)he
		; has decided to change RR value type to "vanilla" one.
		; And what will happened next if we does not reset regeneration
		; rate? Correct, (s)he stays with previous value forever!
		; 
		; Solution #1: Periodically retrieve current regeneration rate
		; and keep them inside this module. Good, but...
		;
		; Issue #2: If we remember regeneration rate value under 
		; effect like potion, then we had remembered WRONG value.
		; When the effect has been passed this will be a cause of 
		; reducing/increasing an actual regeneration rate to some value
		; forever. Forever!
		; Just because I should take care of it, but I did not.
		; In other words we've restored the regeneration rate 
		; to a WRONG value!
		;
		; Solution #2: Always return default regeneration rate value.
		; Fixing regeneration rates for other mods is not my problem.
		; At least, until I find good solution for that.
		;
		; Solution #3: User is able to decide what (s)he want.
		; I can guarantee that everything will be fine 
		; when (s)he uses non-vanilla settings. That's means that this
		; mod is taking responsibility to control and modify x-rates
		; values directly.
		; And ONLY in such case.
		;
		; That's means that this module will never call function:
		;   player.ForceAV([heal|magicka|stamina]Rate, <someValue>)
		; while RRHealRateIndex, RRMagickaRateIndex, RRStaminaRateIndex
		; has value equals to RRFunctionVanilla.GetValueInt()
		;
		; Never!
		;
		return -1.0
	endIf
endFunction

int Function getRateFunctionByName( string avName )
	int iIndex = rateNamesList.Find( avName )

	if ( iIndex == -1 )
		Debug.Notification("RR getRateFunctionByName invalid avName: " + avName)
		return RRFunctionVanilla.GetValueInt()
	endIf

	if ( enabledList[iIndex].GetValueInt() == 1 )
		return rateIndexList[iIndex].GetValueInt()
	else
		return RRFunctionVanilla.GetValueInt()
	endIf
endFunction

Function restoreDefaultSettings()
	removeAllSpells()

	if ( RRUninstall.GetValueInt() == 1 )
		restoreDefaultRegeneration()
		restoreDefaultCombatMults()
	endIf
endFunction

Function restoreDefaultRegeneration()
	PlayerREF.ForceAV( "HealRate", defaultHealRate )
	PlayerREF.ForceAV( "StaminaRate", defaultStaminaRate )
	PlayerREF.ForceAV( "MagickaRate", defaultMagickaRate )
endFunction

Function restoreDefaultCombatMults()
	PlayerREF.ForceAV( "CombatHealthRegenMult", defaultCombatHealMult )
	Game.SetGameSettingFloat( "fCombatMagickaRegenRateMult", defaultCombatMagickaMult )
	Game.SetGameSettingFloat( "fCombatStaminaRegenRateMult", defaultCombatStaminaMult )
endFunction

Function removeAllSpells( string avName = "undefined" )
	int avOnly = avNamesList.Find( avName )

	removeAllSpellsFromList( sittingSpellList, avOnly )
	removeAllSpellsFromList( runningSpellList, avOnly )
	removeAllSpellsFromList( potionsSpellList, avOnly )
	removeAllSpellsFromList( sprintSpellList, avOnly )
	removeAllSpellsFromList( foodSpellList, avOnly )
	removeAllSpellsFromList( combatSpellList, avOnly )
	removeAllSpellsFromList( itemsSpellList, avOnly )
	removeAllSpellsFromList( spellsSpellList, avOnly )

	removeAllSpellsFromList( specialSpellList )
endFunction

Function removeAllSpellsFromList(Spell[] list, int avOnly = -1)
	int index = 0

	if (avOnly == -1)
		While index < list.Length
			Spell aSpell = list[index]

			if (PlayerREF.HasSpell(aSpell))
				PlayerREF.RemoveSpell(aSpell)
			endIf

			index += 1
		endWhile
	else
		Spell aSpell = list[avOnly]

		if (PlayerREF.HasSpell(aSpell))
			PlayerREF.RemoveSpell(aSpell)
		endIf
	endIf
endFunction

Function addAllSpellsFromList(Spell[] list, Bool[] checkList)
	int index = 0

	While index < list.Length
		if (checkList[index])
			PlayerREF.AddSpell(list[index], isDebug())
		endIf

		index += 1
	endWhile
endFunction

; -- added in 3.09
Function addAllSpellsFromList2(Spell[] list, GlobalVariable[] checkList)
	int index = 0

	While index < list.Length
		if checkList[index].GetValueInt() == 1
			PlayerREF.AddSpell(list[index], isDebug())
		endIf

		index += 1
	endWhile
endFunction


float Function getDefaultHealRate()
	return defaultHealRate
endFunction

float Function getDefaultMagickaRate()
	return defaultMagickaRate
endFunction

float Function getDefaultStaminaRate()
	return defaultStaminaRate
endFunction

; Combat

float Function getDefaultCombatHealMult()
	return defaultCombatHealMult
endFunction

float Function getDefaultCombatMagickaMult()
	return defaultCombatMagickaMult
endFunction

float Function getDefaultCombatStaminaMult()
	return defaultCombatStaminaMult
endFunction

; Attributes

float[] Function getBaseAttrList()
	float[] fAttrList = new float[3]
	int iIndex = 0

	While ( iIndex < avNamesList.Length )
		fAttrList[iIndex] = PlayerREF.GetBaseAV( avNamesList[iIndex] )
		iIndex += 1
	EndWhile

	return fAttrList
EndFunction

float Function getBaseAttrByName( string avName )
	return PlayerREF.GetBaseAV( avName )
EndFunction

float Function getAttrByName( string avName )
	return PlayerREF.GetActorValue( avName )
EndFunction


float Function GetPerkValueByPriority( Perk aPerk, int iPriority, int iValueIdx = 0 )
	int index = 0
	int entries = aPerk.GetNumEntries()

	While index < entries
		if ( aPerk.GetNthEntryPriority( index ) == iPriority )
			return aPerk.GetNthEntryValue( index, iValueIdx )
		endIf

		index += 1
	EndWhile

	return -1.0
EndFunction

int Function SetPerkValueByPriority( Perk aPerk, int iPriority, float fValue, int iValueIdx = 0)
	int index = 0
	int entries = aPerk.GetNumEntries()
	int iModifiedEntries = 0

	While index < entries
		if ( aPerk.GetNthEntryPriority( index ) == iPriority )
			aPerk.SetNthEntryValue( index, iValueIdx, fValue )
			iModifiedEntries += 1
		endIf

		index += 1
	EndWhile

	return iModifiedEntries
EndFunction

;
; EVENTS & STATES ---------------------------------------------------------------------------------
;

State onAddSpells
	Event OnUpdate()
		if (!isActive())
			deactivate()
			return
		endIf

		addAllSpellsFromList(sittingSpellList, sittingToAddList)
		addAllSpellsFromList(runningSpellList, runningToAddList)
		addAllSpellsFromList(potionsSpellList, potionsToAddList)
		addAllSpellsFromList(sprintSpellList, sprintToAddList)
		addAllSpellsFromList(foodSpellList, foodToAddList)
		addAllSpellsFromList(combatSpellList, combatToAddList)
		addAllSpellsFromList(itemsSpellList, itemsToAddList)
		addAllSpellsFromList(spellsSpellList, spellsToAddList)

		; -- added in 3.09
		addAllSpellsFromList2(specialSpellList, specialIndexList)

		UnregisterForUpdate()
		GotoState("Inactive")
	endEvent
endState

Event OnUpdate()
	; nop
EndEvent

State Inactive
	Event OnUpdate()
		; nop
	EndEvent
EndState
