Scriptname RRSkyUILibScript extends Quest
{Library for RRSkyUIConfigMenuScript}

;
; GLOBAL VARIABLES --------------------------------------------------------------------------------
;

; Game
Actor Property PlayerREF Auto

; Scripts

RRControlScript           Property RRControl       Auto
RRWhenSleepScript         Property RRWhenSleep     Auto
RRWhenWaitScript          Property RRWhenWait      Auto
RRInGameScript            Property RRInGame        Auto
RRBoostersScript          Property RRBoosters      Auto
RRFatigueBowstringScript  Property RRBowstring     Auto
RRAttributesScript        Property RRAttributes    Auto
RRGameSettingsScript      Property RRGameSettings  Auto


; Main

GlobalVariable Property RREnabled Auto

GlobalVariable Property RRHealEnabled Auto
GlobalVariable Property RRMagickaEnabled Auto
GlobalVariable Property RRStaminaEnabled Auto

; Default

GlobalVariable Property RRHealRateIndex Auto
GlobalVariable Property RRHealRate Auto

GlobalVariable Property RRMagickaRateIndex Auto
GlobalVariable Property RRMagickaRate Auto

GlobalVariable Property RRStaminaRateIndex Auto
GlobalVariable Property RRStaminaRate Auto

; Sleep

GlobalVariable Property RRSleepHealIndex Auto
GlobalVariable Property RRSleepHealValue Auto

GlobalVariable Property RRSleepMagickaIndex Auto
GlobalVariable Property RRSleepMagickaValue Auto

GlobalVariable Property RRSleepStaminaIndex Auto
GlobalVariable Property RRSleepStaminaValue Auto

; Wait

GlobalVariable Property RRWaitHealIndex Auto
GlobalVariable Property RRWaitHealValue Auto

GlobalVariable Property RRWaitMagickaIndex Auto
GlobalVariable Property RRWaitMagickaValue Auto

GlobalVariable Property RRWaitStaminaIndex Auto
GlobalVariable Property RRWaitStaminaValue Auto

GlobalVariable Property RRMinWaitPeriod Auto

; Sitting

GlobalVariable Property RRSittingHealIndex Auto
GlobalVariable Property RRSittingHealValue Auto

GlobalVariable Property RRSittingMagickaIndex Auto
GlobalVariable Property RRSittingMagickaValue Auto

GlobalVariable Property RRSittingStaminaIndex Auto
GlobalVariable Property RRSittingStaminaValue Auto

; Running

GlobalVariable Property RRRunningHealIndex Auto
GlobalVariable Property RRRunningHealValue Auto

GlobalVariable Property RRRunningMagickaIndex Auto
GlobalVariable Property RRRunningMagickaValue Auto

GlobalVariable Property RRRunningStaminaIndex Auto
GlobalVariable Property RRRunningStaminaValue Auto

; Sprint

GlobalVariable Property RRSprintHealIndex Auto
GlobalVariable Property RRSprintHealValue Auto

GlobalVariable Property RRSprintMagickaIndex Auto
GlobalVariable Property RRSprintMagickaValue Auto

GlobalVariable Property RRSprintStaminaIndex Auto
GlobalVariable Property RRSprintStaminaValue Auto

; Potion

GlobalVariable Property RRPotionRegenHealIndex Auto
GlobalVariable Property RRPotionRegenHealValue Auto

GlobalVariable Property RRPotionRegenMagickaIndex Auto
GlobalVariable Property RRPotionRegenMagickaValue Auto

GlobalVariable Property RRPotionRegenStaminaIndex Auto
GlobalVariable Property RRPotionRegenStaminaValue Auto

; Food

GlobalVariable Property RRFoodHealIndex Auto
GlobalVariable Property RRFoodHealValue Auto

GlobalVariable Property RRFoodMagickaIndex Auto
GlobalVariable Property RRFoodMagickaValue Auto

GlobalVariable Property RRFoodStaminaIndex Auto
GlobalVariable Property RRFoodStaminaValue Auto

; Beast

GlobalVariable Property RRWerewolfIndex Auto

; Combat

GlobalVariable Property RRCombatMultHealIndex Auto
GlobalVariable Property RRCombatMultHealValue Auto

GlobalVariable Property RRCombatMultMagickaIndex Auto
GlobalVariable Property RRCombatMultMagickaValue Auto

GlobalVariable Property RRCombatMultStaminaIndex Auto
GlobalVariable Property RRCombatMultStaminaValue Auto


GlobalVariable Property RRCombatHealIndex Auto
GlobalVariable Property RRCombatHealValue Auto

GlobalVariable Property RRCombatMagickaIndex Auto
GlobalVariable Property RRCombatMagickaValue Auto

GlobalVariable Property RRCombatStaminaIndex Auto
GlobalVariable Property RRCombatStaminaValue Auto

; Items

GlobalVariable Property RRItemsHealIndex Auto
GlobalVariable Property RRItemsHealValue Auto

GlobalVariable Property RRItemsMagickaIndex Auto
GlobalVariable Property RRItemsMagickaValue Auto

GlobalVariable Property RRItemsStaminaIndex Auto
GlobalVariable Property RRItemsStaminaValue Auto

; Spells

GlobalVariable Property RRSpellsHealIndex Auto
GlobalVariable Property RRSpellsHealValue Auto

GlobalVariable Property RRSpellsMagickaIndex Auto
GlobalVariable Property RRSpellsMagickaValue Auto

GlobalVariable Property RRSpellsStaminaIndex Auto
GlobalVariable Property RRSpellsStaminaValue Auto

; Constants

GlobalVariable Property RRFunctionNoHeal Auto
GlobalVariable Property RRFunctionDefault Auto
GlobalVariable Property RRFunctionUserDefined Auto
GlobalVariable Property RRFunctionVanilla Auto

;
; PRIVATE VARIABLES -------------------------------------------------------------------------------
;

int[]      iCurrentSettingsList
float[]    fCurrentSettingsList
bool       bSaveSlotStatus

float[]    fRatesAndAttrsList
float[]    fStatsList

;
; FUNCTIONS : Helpful -------------------------------------------------------------------------=---
;

Function toggle( GlobalVariable value )
	if ( value.getValueInt() == 0 )
		value.setValueInt( 1 )
	else
		value.setValueInt( 0 )
	endIf
EndFunction

;
; getRRCV - Get Realistic Regeneration Current Value
;
; Return:
;	Current value depending on function type fType, like RRFunctionUserDefined.GetValueInt()
;	Return current player actor value when fType == RRFunctionVanilla.GetValueInt()
;
float Function getRRCV( int fType, GlobalVariable gvValue, string avName )
	if ( fType == RRFunctionNoHeal.GetValueInt() )
		return 0.0
	elseif ( fType == RRFunctionDefault.GetValueInt() )
		return RRControl.getDefaultRate( avName )
	elseif ( fType == RRFunctionUserDefined.GetValueInt() )
		return gvValue.GetValue()
	elseif ( fType == RRFunctionVanilla.GetValueInt() )
		return PlayerREF.GetActorValue( RRControl.getRateNameByAVName( avName ) )
	else
		Debug.Notification( "getRRCV wrong value: " + avName )
		return PlayerREF.GetActorValue( RRControl.getRateNameByAVName( avName ) )
	endIf
endFunction

;
; getRRCVMult - Get Realistic Regeneration Current Value Multiplier
;
; Return:
;	Current value depending on function type fType, like RRFunctionUserDefined.GetValueInt()
;	Return current game setting value when fType == RRFunctionVanilla.GetValueInt()
;
float Function getRRCVMult( int fType, GlobalVariable gvValue, string avName )
	if ( fType == RRFunctionNoHeal.GetValueInt() )
		return 0.0
	elseif ( fType == RRFunctionDefault.GetValueInt() )
		return RRControl.getDRCombatMult( avName )
	elseif ( fType == RRFunctionUserDefined.GetValueInt() )
		return gvValue.GetValue()
	else ; vanilla
		return RRControl.getCurrentCombatMult( avName )
	endIf
endFunction

;
; getRRCVMult - Get Realistic Regeneration Current Value For Werewolf
;
; Return:
;	Current value depending on function type fType, like RRFunctionUserDefined.GetValueInt()
;	Return default game setting value when fType == RRFunctionVanilla.GetValueInt()
;	* Because we do not know what value is set other mod. Not a telepate!
;
float Function getRRCVWerewolf( int fType, GlobalVariable gvValue, string avName )
	if ( fType == RRFunctionNoHeal.GetValueInt() )
		return 0.0
	elseif ( fType == RRFunctionDefault.GetValueInt() )
		return RRControl.getDefaultWerewolfRate( avName )
	elseif ( fType == RRFunctionUserDefined.GetValueInt() )
		return gvValue.GetValue()
	elseif ( fType == RRFunctionVanilla.GetValueInt() )
		return RRControl.getDefaultWerewolfRate( avName )
	else
		Debug.Notification( "getRRCVWerewolf wrong value: " + avName )
		return RRControl.getDefaultWerewolfRate( avName )
	endIf
endFunction

Function resetAll()
	RRControl.reset()
	RRWhenSleep.reset()
	RRWhenWait.reset()
	RRInGame.reset()
	RRBoosters.reset()
	RRBowstring.reset()
	RRAttributes.reset()
	RRGameSettings.reset()
endFunction

Function initializeAll()
	RRControl.initializeVariables()
	RRWhenSleep.initializeAll()
	RRWhenWait.initializeAll()
	RRInGame.initializeAll()
	RRBoosters.initializeAll()
	RRBowstring.initializeAll()
	RRAttributes.initializeAll()
	RRGameSettings.initializeAll()
EndFunction

Function doVersionUpdate( int oldVersion, int newVersion )
	If oldVersion <= 307
		RRGameSettings.updateAll()
		RRAttributes.updateAll()
	EndIf

	If (( oldVersion <= 309 ) && ( oldVersion >= 308 ))
		RRGameSettings.updateAll( 8 )
	EndIf

	Debug.Notification("$RRnotifyUpdated")
EndFunction


;
; FUNCTIONS : Save & Load -------------------------------------------------------------------------
;

Function setSaveSlot()
	bSaveSlotStatus = false
	iCurrentSettingsList = new int[37]
	fCurrentSettingsList = new float[36]
endFunction

bool Function isSaveSlotFull()
	return bSaveSlotStatus
endFunction

Function saveSettings()
	GlobalVariable[] iGVlist = getGVintList()
	int index = 0

	While index < iGVlist.Length
		iCurrentSettingsList[index] = iGVlist[index].GetValueInt()
		index += 1
	endWhile

	GlobalVariable[] fGVlist = getGVfloatList()
	index = 0

	While index < fGVlist.Length
		fCurrentSettingsList[index] = fGVlist[index].GetValue()
		index += 1
	endWhile

	bSaveSlotStatus = true
endFunction

Function loadSettings()
	GlobalVariable[] iGVlist = getGVintList()
	int index = 0

	While index < iGVlist.Length
		iGVlist[index].SetValueInt(iCurrentSettingsList[index])
		index += 1
	endWhile

	GlobalVariable[] fGVlist = getGVfloatList()
	index = 0

	While index < fGVlist.Length
		fGVlist[index].SetValue(fCurrentSettingsList[index])
		index += 1
	endWhile
endFunction

GlobalVariable[] Function getGVintList()
	GlobalVariable[] _gvIntList = new GlobalVariable[37]

	_gvIntList[0] = RRHealEnabled
	_gvIntList[1] = RRMagickaEnabled
	_gvIntList[2] = RRStaminaEnabled
	_gvIntList[3] = RRWerewolfIndex
	_gvIntList[4] = RRHealRateIndex
	_gvIntList[5] = RRMagickaRateIndex
	_gvIntList[6] = RRStaminaRateIndex
	_gvIntList[7] = RRSleepHealIndex
	_gvIntList[8] = RRSleepMagickaIndex
	_gvIntList[9] = RRSleepStaminaIndex
	_gvIntList[10] = RRSittingHealIndex
	_gvIntList[11] = RRSittingMagickaIndex
	_gvIntList[12] = RRSittingStaminaIndex
	_gvIntList[13] = RRRunningHealIndex
	_gvIntList[14] = RRRunningMagickaIndex
	_gvIntList[15] = RRRunningStaminaIndex
	_gvIntList[16] = RRSprintHealIndex
	_gvIntList[17] = RRSprintMagickaIndex
	_gvIntList[18] = RRSprintStaminaIndex
	_gvIntList[19] = RRPotionRegenHealIndex
	_gvIntList[20] = RRPotionRegenMagickaIndex
	_gvIntList[21] = RRPotionRegenStaminaIndex
	_gvIntList[22] = RRFoodHealIndex
	_gvIntList[23] = RRFoodMagickaIndex
	_gvIntList[24] = RRFoodStaminaIndex
	_gvIntList[25] = RRCombatMultHealIndex
	_gvIntList[26] = RRCombatMultMagickaIndex
	_gvIntList[27] = RRCombatMultStaminaIndex
	_gvIntList[28] = RRCombatHealIndex
	_gvIntList[29] = RRCombatMagickaIndex
	_gvIntList[30] = RRCombatStaminaIndex
	_gvIntList[31] = RRItemsHealIndex
	_gvIntList[32] = RRItemsMagickaIndex
	_gvIntList[33] = RRItemsStaminaIndex
	_gvIntList[34] = RRSpellsHealIndex
	_gvIntList[35] = RRSpellsMagickaIndex
	_gvIntList[36] = RRSpellsStaminaIndex

	return _gvIntList
endFunction

GlobalVariable[] Function getGVfloatList()
	GlobalVariable[] _gvFloatList = new GlobalVariable[36]

	_gvFloatList[0] = RRHealRate
	_gvFloatList[1] = RRMagickaRate
	_gvFloatList[2] = RRStaminaRate
	_gvFloatList[3] = RRSleepHealValue
	_gvFloatList[4] = RRSleepMagickaValue
	_gvFloatList[5] = RRSleepStaminaValue
	_gvFloatList[6] = RRRunningHealValue
	_gvFloatList[7] = RRRunningMagickaValue
	_gvFloatList[8] = RRRunningStaminaValue
	_gvFloatList[9] = RRSprintHealValue
	_gvFloatList[10] = RRSprintMagickaValue
	_gvFloatList[11] = RRSprintStaminaValue
	_gvFloatList[12] = RRSittingHealValue
	_gvFloatList[13] = RRSittingMagickaValue
	_gvFloatList[14] = RRSittingStaminaValue
	_gvFloatList[15] = RRPotionRegenHealValue
	_gvFloatList[16] = RRPotionRegenMagickaValue
	_gvFloatList[17] = RRPotionRegenStaminaValue
	_gvFloatList[18] = RRFoodHealValue
	_gvFloatList[19] = RRFoodMagickaValue
	_gvFloatList[20] = RRFoodStaminaValue
	_gvFloatList[21] = RRCombatMultHealValue
	_gvFloatList[22] = RRCombatMultMagickaValue
	_gvFloatList[23] = RRCombatMultStaminaValue
	_gvFloatList[24] = RRCombatHealValue
	_gvFloatList[25] = RRCombatMagickaValue
	_gvFloatList[26] = RRCombatStaminaValue
	_gvFloatList[27] = RRItemsHealValue
	_gvFloatList[28] = RRItemsMagickaValue
	_gvFloatList[29] = RRItemsStaminaValue
	_gvFloatList[30] = RRSpellsHealValue
	_gvFloatList[31] = RRSpellsMagickaValue
	_gvFloatList[32] = RRSpellsStaminaValue
	_gvFloatList[33] = RRWaitHealValue
	_gvFloatList[34] = RRWaitMagickaValue
	_gvFloatList[35] = RRWaitStaminaValue

	return _gvFloatList
endFunction

;
; FUNCTIONS Rates and attributes showcase ---------------------------------------------------------
;

Function setRatesAndAttrs()
	fRatesAndAttrsList = new float[12]
	fStatsList = new float[12]

	int iIndex = 0
	while ( iIndex < fRatesAndAttrsList.Length )
		fRatesAndAttrsList[iIndex] = 0.0
		iIndex += 1
	endWhile

	iIndex = 0
	while ( iIndex < fStatsList.Length )
		fStatsList[iIndex] = 0.0
		iIndex += 1
	endWhile
endFunction

Function updateRatesAndAttrs()
	; h, m, s  |
	;-+--+--+--|
	; 0, 4, 8  | - attributes
	; 1, 5, 9  | - rates
	; 2, 6, 10 | - rateMult
	; 3, 7, 11 | - combat rateMult

	int rIndex = 0
	int iIndex = 0
	while ( iIndex < 3 )
		fRatesAndAttrsList[rIndex] = RRControl.getCurrentAttrByIndex(iIndex)
		rIndex += 1
		fRatesAndAttrsList[rIndex] = RRControl.getCurrentRateByIndex(iIndex)
		rIndex += 1
		fRatesAndAttrsList[rIndex] = RRControl.getCurrentRateMultByIndex(iIndex)
		rIndex += 1
		fRatesAndAttrsList[rIndex] = RRControl.getCurrentCombatRateMultByIndex(iIndex)
		rIndex += 1

		iIndex += 1
	endWhile

	; attributes
	fStatsList[0] = fRatesAndAttrsList[0]
	fStatsList[1] = fRatesAndAttrsList[4]
	fStatsList[2] = fRatesAndAttrsList[8]

	; rates
	fStatsList[3] = fRatesAndAttrsList[1]
	fStatsList[4] = fRatesAndAttrsList[5]
	fStatsList[5] = fRatesAndAttrsList[9]

	; per second formala: 
	; in prercent per sec: ( rate * rateMult ) / 100
	; in per second: hp * < in prercent per sec > / 100
	; full recond in per second: hp * ( rate * rateMult ) / 10000
	fStatsList[6] = (fRatesAndAttrsList[0] * fRatesAndAttrsList[1] * fRatesAndAttrsList[2] ) / 10000
	fStatsList[7] = (fRatesAndAttrsList[4] * fRatesAndAttrsList[5] * fRatesAndAttrsList[6] ) / 10000
	fStatsList[8] = (fRatesAndAttrsList[8] * fRatesAndAttrsList[9] * fRatesAndAttrsList[10] ) / 10000

	; per second in combat formula:
	; full recond in per second: hp * ( rate * combatRateMult * rateMult ) / 10000
	fStatsList[9]  = (fRatesAndAttrsList[0] * fRatesAndAttrsList[1] * fRatesAndAttrsList[3] * fRatesAndAttrsList[2] ) / 10000
	fStatsList[10] = (fRatesAndAttrsList[4] * fRatesAndAttrsList[5] * fRatesAndAttrsList[7] * fRatesAndAttrsList[6] ) / 10000
	fStatsList[11] = (fRatesAndAttrsList[8] * fRatesAndAttrsList[9] * fRatesAndAttrsList[11] *fRatesAndAttrsList[10] ) / 10000
EndFunction

float[] Function getStatsList()
	return fStatsList
endFunction
